#include "Global.h"
#define	 CD_Nmax		19		/* limit codim */

/*  ========   CoordHyperPlane-faces, neighbor-facets, symmetries   ======== *
 *  use CHPs to construct faces, codim-2-faces to find neighboring facets and 
 *  symmetries to reduce the redundancy. CHP_Equations omits coordinates and
 *  recursively constructs CHP-facets, and then the others. The whole thing 
 *  works only if non-CHP-facets have no more than VERT_Nmax vertices.
 *  
 */
/*	Facet: {UC omit[cd], int ne,np,net, Eq[ne]}} size=cd+3*int+ne*Eq -> Fli
 *		Fnum[CDmax] Foff[CDmax] -> Fspl = sorted pointer list [-> Fli]
 *		CHP order defined by omitted points  ... only CHP facets !!!??
 *      RawEqList RF ... q -> cd2Faces = rawFeqs -> SymMin, new => 
 *	find cd2Faces;   one equationlist + (sortpointer,raw-flag)
 *	      SortAddEq(Eq, Eqlist) {return not found;}
 *      recover vertices: study incidences and dual inci's
 */
/* cd2F::VLNx={n1...n#v}  ...  GLZ-SS -> 2 Eqs.  ... only store SYN-NF and
   immediately find equation for facet on the other side.*/ 
/* ---------------------------------------------------------------------------
CHP_Equations	-> Norm_Omit; Find_Norm_CHP; Make_Norm_CHP_Eqs; Back_Transform
  Norm_Omit(cd,mset,ST,S) 	-> mset[]=oset[L[omit[]], L=S->CL[*ST].L
  Find_Norm_CHP(S,cd,mset,ne,Eq)-> if() Eq=&(equation in list=S.Fli)
  Make_Norm_CHP_Eqs(P,cd,mset,S,ST,ns,ne,Eq)
	-> if(X->np<=VERT_Nmax) Find_Equations; else CHP_Equations(P,S,cd+1,E);
 */
/*   RS_CHP_Equations(&P,&E): Make_Symmetries; CHP_Equations (=CoordHyperPlane)
 *
 *	CHP_Equations(&P,&E);			... SymData.omit[]
 *	-> Norm_Omit(cd,mset,ST,S); -> mset[]=oset[L[omit[]], L=S->CL[*ST].L
 *	-> if(!Find_Norm_CHP()) if(!Make_Norm_CHP_Eqs()) return 0;
 *	-> Back_Transform
 *
 *	Make_Norm_CHP_Eqs(P,cd,mset,S,ST,ns,&ne,Eq)
 *	-> Make_CHP_PPL(); GLZ_Start_Simplex();
 *	-> if(X->np<=VERT_Nmax) {Find_Equations(X,&V,E);Check_EqList(E,X);}
 *	-> else net=CHP_Equations(P,S,cd+1,E);
 *	-> Eq=Put_Norm_CHP(E,S,cd,mset,X->np,net);
 *
 *	Norm_Omit(cd,mset,ST,S); 	mset[]=oset[L[omit[]], L=S->CL[*ST].L
 */
/*	Facet: {UC omit[cd], int ne,np,net, Eq[ne]}} size=cd+3*int+ne*Eq -> Fli
 *		Fnum[CDmax] Foff[CDmax] -> Fspl = sorted pointer list [-> Fli]
 *		CHP order defined by omitted points  ... only CHP facets !!!??? *
 *      RawEqList RF ... q -> cd2Faces = rawFeqs -> SymMin, new => 
 *	find cd2Faces;   one equationlist + (sortpointer,raw-flag)
 *	      SortAddEq(Eq, Eqlist) {return not found;}
 *      recover vertices: study incidences and dual inci's
 */

/* cd2F::VLNx={n1...n#v}  ...  GLZ-SS -> 2 Eqs.  ... only store SYN-NF and
   immediately find equation for facet on the other side. */
	


#define	COUNT_ONLY	0
#define	KF_ALLOC	20000		/* Facets: allocate UC [ 1000*KF ] */ 
#define	TestNoIP	1		/* if(#IPs>0)  -1: warn, +1: exit */

#define	UC		unsigned char
#define US		unsigned short
#define	UCM		256
#define USM		65536
#define	UN		UC		/* vertex/Pt. numbers for cd2-faces */
#define	UNM		UCM		/* 1 + maximal value of UN */

#define L_Nmax		POLY_Dmax
#define C_Nmax		POINT_Nmax
typedef struct {int C[C_Nmax], L[L_Nmax];}             		PERM;  

typedef struct {PERM *CL; int ns; int d;  /* only store CHP facets: !!! ??? */
		UC *Fli; int Fp, Fa;       /* Fposition <= Fa=1000*KF_ALLOC */
		int Nspl,Fnum[CD_Nmax+1],Foff[CD_Nmax+1]; UC *Fspl[EQUA_Nmax];
		int omit[CD_Nmax+1]; int FE, FC;}		SymData;

void InitSymData(SymData *S, int *d)
{    int i; S->FE=S->FC=0; S->d=*d; S->Fp=S->Nspl=0; 
     for(i=0;i<=CD_Nmax;i++) S->Fnum[i]=S->Foff[i]=0;
     assert(NULL != ( S->Fli = (UC *) malloc(S->Fa=1000*KF_ALLOC) ) );
}    void FreeSymData(SymData *S) { free(S->Fli); }

/*	Facet: {UC omit[cd], int ne,np,net, Eq[ne]}} size=cd+3*int+ne*Eq -> Fli
 *		Fnum[CDmax] Foff[CDmax] -> Fspl = sorted pointer list [-> Fli]
 *		CHP order defined by omitted points  ... only CHP facets !!!??? 
 *
 *      RawEqList RF ... q -> cd2Faces = rawFeqs -> SymMin, new => 
 *	find cd2Faces;   one equationlist + (sortpointer,raw-flag)
 *	      SortAddEq(Eq, Eqlist) {return not found;}
 *      recover vertices: study incidences and dual inci's
 */
/* cd2F::VLNx={n1...n#v}  ...  GLZ-SS -> 2 Eqs.  ... only store SYN-NF and
   immediately find equation for facet on the other side. */
		



/* ========   CoordHyperPlane-faces, neighbor-facets, symmetries   ======== *
use CHPs to construct faces, codim-2-faces to find neighboring facets
and symmetries to reduce the redundancy. CHP_Equations omits coordinates and
recursively constructs CHP-facets, and then the others. The whole thing works
only if non-CHP-facets have no more than VERT_Nmax vertices.
-----------------------------------------------------------------------------
CHP_Equations	-> Norm_Omit; Find_Norm_CHP; Make_Norm_CHP_Eqs; Back_Transform
  Norm_Omit(cd,mset,ST,S) 	-> mset[]=oset[L[omit[]], L=S->CL[*ST].L
  Find_Norm_CHP(S,cd,mset,ne,Eq)-> if() Eq=&(equation in list=S.Fli)
  Make_Norm_CHP_Eqs(P,cd,mset,S,ST,ns,ne,Eq)
	-> if(X->np<=VERT_Nmax) Find_Equations; else CHP_Equations(P,S,cd+1,E);
 */

/* Start_CHP_Equations(&P,&E): Make_Symmetries; CHP_Equations (CoordHyperPlane)
 *
 *	CHP_Equations(&P,&E);			... SymData.omit[]
 *	-> Norm_Omit(cd,mset,ST,S); -> mset[]=oset[L[omit[]], L=S->CL[*ST].L
 *	-> if(!Find_Norm_CHP()) if(!Make_Norm_CHP_Eqs()) return 0;
 *	-> Back_Transform
 *
 *	Make_Norm_CHP_Eqs(P,cd,mset,S,ST,ns,&ne,Eq)
 *	-> Make_CHP_PPL(); GLZ_Start_Simplex();
 *	-> if(X->np<=VERT_Nmax) {Find_Equations(X,&V,E);Check_EqList(E,X);}
 *	-> else net=CHP_Equations(P,S,cd+1,E);
 *	-> Eq=Put_Norm_CHP(E,S,cd,mset,X->np,net);
 *
 *	Norm_Omit(cd,mset,ST,S); 	mset[]=oset[L[omit[]], L=S->CL[*ST].L
 */
/*	Facet: {UC omit[cd], int ne,np,net, Eq[ne]}} size=cd+3*int+ne*Eq -> Fli
 *		Fnum[CDmax] Foff[CDmax] -> Fspl = sorted pointer list [-> Fli]
 *		CHP order defined by omitted points  ... only CHP facets !!!??? *
 *      RawEqList RF ... q -> cd2Faces = rawFeqs -> SymMin, new => 
 *	find cd2Faces;   one equationlist + (sortpointer,raw-flag)
 *	      SortAddEq(Eq, Eqlist) {return not found;}
 *      recover vertices: study incidences and dual inci's
 */

/* cd2F::VLNx={n1...n#v}  ...  GLZ-SS -> 2 Eqs.  ... only store SYN-NF and
   immediately find equation for facet on the other side. */
		
/* ====================================================================== */

FILE *inFILE, *outFILE;

#ifndef	CEQ_Nmax	
#define CEQ_Nmax        EQUA_Nmax
#endif



typedef struct {int ne; Equation e[CEQ_Nmax];}              	CEqList;

int  Start_CHP_Equations(PolyPointList *P,EqList *E);     /* return ne-tot */
int  GLZ_Start_Simplex(PolyPointList *_P, VertexNumList *_V, CEqList *_C);

void PrintUsage(char *c){ 
     puts("-f	use as filter");
     puts("-n	don't use symmetries");	exit(0);
}
int  CHP_Equations(PolyPointList *P,SymData *S,int cd,EqList *E);


main (int narg, char* fn[])
{    int n=0, k, FilterFlag=0, ineq=1; char c; static EqList E;
     static CWS CW; static PolyPointList P; static VertexNumList V;
     while(narg > ++n)
     {	if(fn[n][0]!='-') break; k=0;
     	while ((c=fn[n][++k])!='\0')
     	{   if(c=='h') { PrintUsage(fn[0]); exit(0);}
      	    if(c=='f') FilterFlag=1; 
      	    if(c=='n') ineq=0;
     	}
     }  n--;
     if(FilterFlag) {inFILE=NULL; outFILE=stdout;} else  
     {  if (narg > ++n)  inFILE=fopen(fn[n],"r"); else inFILE=stdin;
        if(inFILE==NULL){printf("In file %s not found!\n",fn[n]);exit(0);}
        if (narg > ++n) outFILE=fopen(fn[n],"w"); else outFILE=stdout;
     }	while(Read_CWS_PP(&CW,&P)) Start_CHP_Equations(&P,&E); /* return ne-tot */
     if(ineq>1) printf("#eq=%d  (%d up to symmetries)\n",E.ne,ineq);
}

/*   =====================================================================   */
typedef struct {int nv, nf, ns;}                       	vNF;  /*nv < C_Nmax */
void Aux_vNF_Line(int l,vNF *_X,Long x[][C_Nmax], PERM *CL,int *S,int *_ns)
{    int n=(*_ns), cf=0;	/*  cf=CompareFlag (ref. exists & o.k.      */
     Long *y, r[C_Nmax];	/*  r=ReferenceLine; y->X[line]		    */
     while(n--)      /*  go over CL (n from  *_ns-1  to  0), ns_* changes!  */
     {	static PERM nP[C_Nmax];	        
	int c=0, L=l-1, np=0, *C, ccf=cf;	/*  ccf=column compare flag */
	*nP=CL[n];
	while(++L<_X->nf)			/*  init nP (from 1st col.) */
	{   int j=0; C=nP[np].C; y=x[nP[np].L[L]];
	    while(++j<=*S) if(y[C[c]]<y[C[j]]) swap(&C[c],&C[j]);
	    if(ccf)
	    {   Long d=y[*C]-*r;
		if(d<0) ;					/* BAD line */
		else if(d)				     /* BETTER line */
		{   *r=y[*C]; cf=0; *nP=nP[np]; nP[np=1]=CL[n]; *_ns=n+1;
		    swap(&(nP->L[l]),&(nP->L[L]));
		}
		else					      /* EQUAL line */
		{   swap(&(nP[np].L[l]),&(nP[np].L[L])); nP[++np]=CL[n];
		}
	    }
	    else 						/* NEW line */
	    {	*r=y[*C]; swap(&(nP[np].L[l]),&(nP[np].L[L]));
		nP[++np]=CL[n]; ccf=1;
	    }
	}
	while(++c<_X->nv)			       /* check/complete nP */
	{   int s=S[c]; L=np; ccf=cf;
	    if(s<c) s=S[s];	
	    while(L--)
	    {	int j=c; C=nP[L].C; y=x[nP[L].L[l]];
		while(++j<=s) if(y[C[c]]<y[C[j]]) swap(&C[c],&C[j]);
		if(ccf)
		{   Long d=y[C[c]]-r[c];
		    if(d<0) {if(--np>L) nP[L]=nP[np];}		/* BAD line */
		    else if(d) 				     /* BETTER line */
		    {	r[c]=y[C[c]]; cf=0; np=L+1; *_ns=n+1;
		    }	/* else	; */			      /* EQUAL line */
		}
		else { r[c]=y[C[c]]; ccf=1; }
	    }
	}
	cf=1;
	if(--(*_ns) > n) CL[n]=CL[*_ns]; 		/*  write nP to CL  */
	if(SYM_Nmax < (cf=(*_ns+np)))
	{   printf("Need SYM_Nmax > %d !!\n",cf);exit(0);
	}
	for(L=0;L<np;L++) CL[(*_ns)++]=nP[L];
     }
     y=x[CL->L[l]];					       /* compute S */
     {	int c=0, *C=CL->C;
	while(c<_X->nv)	
	{   int s=S[c]+1; S[c]=c; while(++c<s)
	    {   if(y[C[c]]==y[C[c-1]]) ++S[ S[c]=S[c-1] ]; 
	        else S[c]=c;
	    }
	}
     }
}
void Aux_vNF_Init(vNF *_X, Long x[][C_Nmax], PERM *CL, int *S, int *_ns)
{    int i, j, nn; Long *b, *y;
     PERM P, *q, *p;		       /* b=x[nb] -> best;  y=x[nn] -> next */
     for(i=0;i<_X->nf;i++) P.L[i]=i;
     for(j=0;j<_X->nv;j++) P.C[j]=j; /* init P */
     q=CL; *q=P; b=*x;          /* P=CL[ns-1] StartPerm; maximize 0-th line */
     for(j=1;j<_X->nv;j++)if(b[q->C[0]]<b[q->C[j]])swap(&q->C[0],&q->C[j]);
     for(i=1;i<_X->nv;i++) 
     {  for(j=i+1;j<_X->nv;j++) if(b[q->C[i]]<b[q->C[j]]) 
        swap(&q->C[i],&q->C[j]);
     }
     for(nn=1;nn<_X->nf;nn++)			     /* maximize nn-th line */
     {  Long d; p=&CL[*_ns]; *p=P; y=x[nn]; /* nb=*q=*b=best, nn=*p=*y=next */
        {   int m=0; for(j=1;j<_X->nv;j++) if(y[p->C[m]]<y[p->C[j]]) m=j;
            if(m) swap(&p->C[0],&p->C[m]);
        }
        if((d=y[p->C[0]]-b[q->C[0]]) < 0) continue;   /* d<0 => forget this */
        for(i=1;i<_X->nv;i++) 
        {   int m=i; for(j=i+1;j<_X->nv;j++) if(y[p->C[m]]<y[p->C[j]]) m=j; 
            if(m>i) swap(&p->C[i],&p->C[m]);
            if(d==0) if((d=y[p->C[i]]-b[q->C[i]]) <0) break;
        }
        if(d<0) continue;
        swap(&p->L[0],&p->L[nn]);		 /* p->L[nn]=0; p->L[0]=nn; */ 
        if(d==0) (*_ns)++; 
        else {*q=*p; *_ns=1; b=y;}                    /* d>0 => forget prev */
     }
     y=x[CL->L[0]]; S[0]=0; for(i=1;i<_X->nv;i++)	       /* compute S */
     if(y[CL->C[i]]==y[CL->C[i-1]]) ++S[ S[i]=S[i-1] ]; else S[i]=i;
}
void Make_VPM_NF(int *v, int *f, Long x[L_Nmax][C_Nmax],      /* in */
		PERM *CL,int *ns)  /* out */
{    int i, j, S[C_Nmax]; 			     /* make VPM NF */
     volatile vNF auX; vNF *_X= (vNF*) &auX;  _X->nv=*v;_X->nf=*f; /* x=VPM */
     *ns=1; Aux_vNF_Init(_X, x, CL, S, ns);              /* init = 1st line */
     for(i=1;i<_X->nf-1;i++)  Aux_vNF_Line(i,_X,x,CL,S,ns);  /* lines of NF */
}
void Make_Symmetries(PolyPointList *P, PERM *CL, int *ns)
{    static Long x[L_Nmax][C_Nmax]; PERM cl, CLi; 
     int i,j, v=P->np, f=P->n;	assert(f<=L_Nmax); assert(v<=C_Nmax); 
     for(i=0;i<f;i++)for(j=0;j<v;j++)x[i][j]=P->x[j][i]; 
     Make_VPM_NF(&v,&f,x,CL,ns);     cl=CL[0]; for(i=0;i<*ns;i++)
     {	PERM CLi=CL[i]; for(j=0;j<f;j++) CL[i].L[cl.L[j]]=CLi.L[j];
	for(j=0;j<v;j++)CL[i].C[cl.C[j]]=CLi.C[j]; /* NF trafos->symmetries*/
     }
}
/*   =====================================================================   */



/*   ==================================================================    */

int  Norm_Omit(int cd, int *mset, int *ST, SymData *S)/* return |STabilizer| */
{    int i,j, n, oset[CD_Nmax+1], R=1;
     for(n=0;n<cd;n++) oset[n]=S->omit[n];
     for(i=1;i<cd;i++) for(j=i;j<cd;j++)
	if(oset[j]<oset[i-1]) swap(&oset[i-1],&oset[j]);  
     for(i=0;i<cd;i++) mset[i]=oset[i]; *ST=0;
     for(n=1; n < S->ns; n++)
     {	int otry[CD_Nmax+1], *L=S->CL[n].L, dif; 
	for(i=0;i<cd;i++) otry[i]=L[oset[i]]; for(i=1;i<cd;i++) 
	    for(j=i;j<cd;j++) if(otry[j]<otry[i-1]) swap(&otry[i-1],&otry[j]); 
        i=0; while(i<cd) if(dif=otry[i]-mset[i]) break; else i++;
	if(dif<0) {*ST=n; R=1; for(j=0;j<cd;j++) mset[j]=otry[j];}
	else if(dif==0) ST[R++]=n;
     }	return R;
}
void Make_CHP_PPL(PolyPointList *P,int cd,int *mset,int *a,PolyPointList *X)
{    int i,j; X->n=P->n-cd; X->np=0; for(i=0;i<P->np;i++) 
     {	for(j=0;j<cd;j++) if(P->x[i][mset[j]]) break; if(j==cd) 
	{   for(j=0;j<X->n;j++) X->x[X->np][j]=P->x[i][a[j]]; X->np++;
	}
     }	
}
void PrintEq(int n, Equation *E)
{    int i; printf("0 <= %d + x (",E->c);
     for(i=0;i<n;i++)printf("%2d ",E->a[i]); puts(")");
}
int  EqLmR(int n, Equation *EL, Equation *ER)
{    int LmR=EL->c-ER->c; if(LmR) return LmR;
     while(n++) if(LmR=EL->a[n]-ER->a[n]) return LmR; return 0;
}
int  Check_EqList(EqList *E,PolyPointList *P)  /* span(facets), 0<=E.c+E.a*X */
{    int i, j, n, fs=0, p[POINT_Nmax]; VertexNumList V;	 /* if set: TestNoIP */
     printf("checking EqList [np=%d ne=%d] ",P->np,E->ne); fflush(0);
     for(i=0;i<P->np;i++) p[i]=0; for(i=0;i<E->ne;i++)
     {	static PolyPointList X; static EqList F; X.np=0; X.n=P->n;
	for(n=0;n<P->np;n++)
	{   Long *x=P->x[n], ev=Eval_Eq_on_V(&E->e[i],x,P->n); if(!ev)p[n]++;
	    if(ev<0) {printf("E-e[%d] negativ on P->x[%d] !!\n",i,n); exit(0);}
	    if(!ev) {for(j=0;j<P->n;j++) X.x[X.np][j]=x[j]; X.np++;}
	}   if(1!=GLZ_Start_Simplex(&X,&V,(CEqList *)&F)) fs++; 
     }	if(fs){puts("F not spanned"); exit(0);} if(TestNoIP)
     {	n=0; for(i=0;i<P->np;i++) if(!p[i]) n++; 
	if(n){printf("#IP=%d\n",n); if(TestNoIP>0) exit(0);}
     }	puts("done"); fflush(0);
}
int  SortAddEq(Equation *Eq,int d,int f,int *F2P,EqList *E)/* Flag+2*Pointer */
{    int m=-1, M=E->ne, lmr;				   /* use bisection */
     if(E->ne) if(0 <= EqLmR(d,&E->e[F2P[E->ne-1]/2],Eq)) while(M-m>1)
     {	int pos=(M+m)/2; if(0 < (lmr=EqLmR(d,Eq,&E->e[pos]))) m=pos; 
	else if(lmr<0) M=pos;
	else {if(f&&!(F2P[pos]%2))F2P[pos]++;return 0;}/* exists -> set flag */
     }	assert(E->ne < EQUA_Nmax); E->e[E->ne]=*Eq;
     for(m=E->ne;M<m;m--)F2P[m]=F2P[m-1]; F2P[m]=f+2*E->ne++; /* insert at M */
}

int  Norm_EqList(EqList *E,int cd,int *mset,int *a,SymData *S,int *ST,int ns)
{    int i,j,n=S->d-cd, ne=0,st,net=0, NE=E->ne; Equation Emin ,*_E;

for(j=0;j<0;j++)PrintEq(n,&(E->e[j]));
printf("Normalize: ST[0]=%d  ne=%d  cd=%d  ns=%d  ",ST[0],NE,cd,ns);
for(i=0;i<cd;i++)printf("%s%d",i?" ":"[",mset[i]);
for(i=0;i<n;i++)printf("%s%d",i?" ":"]  \na=",a[i]);puts("");
for(i=0;i<S->d;i++)assert(i==S->CL[ST[0]].L[i]);

	/* for(i=0;i<ne_old;i++) Ei-> normalized(Ei), insert if not exists
	   among E(<i) => ne++; net+=mult. */
     return NE;
}
void CD2F_to_Eq(PolyPointList X, Equation *F, Equation *Fc);
/*   search Pt in F !in Fc => sign(Fc), minimize Fc(x_0),
 *   Fc'=EEV(Fc,F,x_0) till Fc'(x'_0)=0				*/

/*   Eq(X) <-> mset: sym. x -> p=st0inv(a) -> sti st0inv a -> ainv sti p =pi */
/*   E_aj -> E_a(pi(j)) -> sortadd(E', f=0) ... symcomplete 		*/
int  Complete_EqList(EqList *E,int cd,int *mset,int *a,SymData *S,int *ST,int ns)
{    int i,j,n=S->d-cd, ne=0,st,net=0, NE=E->ne; Equation Emin ,*_E;

for(j=0;j<0;j++)PrintEq(n,&(E->e[j]));
printf("Complete: ST[0]=%d  ne=%d  cd=%d  ns=%d  ",ST[0],NE,cd,ns);
for(i=0;i<cd;i++)printf("%s%d",i?" ":"[",mset[i]);
for(i=0;i<n;i++)printf("%s%d",i?" ":"]  \na=",a[i]);puts("");
for(i=0;i<S->d;i++)assert(i==S->CL[ST[0]].L[i]);

	/* for(i=0;i<ne_old;i++) Ei-> normalized(Ei), insert if not exists
	   among E(<i) => ne++; net+=mult. */ 
     return NE;
}
/* 	put Eq on S->Fspl between "S->Foff[cd]" and "%+S->Fnum[cd]"
 *	Eq <-> {mset ne np net Eq[]} ; 	 spl=SortedPositionList 	*/
int  LmR_mset(int cd, UC *lset, UC *rset)
{    int i=0, dif; assert(cd>0);
     while(!(dif=((int)lset[i])-((int)rset[i])))if(++i==cd)return 0;return dif;
}
Equation* Put_Norm_CHP(EqList *E,SymData *S,int cd,int *mset,int np,int net)
{    int i,j, *L=(int *)&S->Fli[S->Fp+cd], Ppos, 
	nb=cd+3*sizeof(int)+E->ne*sizeof(Equation); UC *Upos=&S->Fli[S->Fp];
     Equation *Eq=(Equation *) &(S->Fli[S->Fp+cd+3*sizeof(int)]); 
/*printf(" Put[");for(i=0;i<cd;i++)printf("%s%d",i?" ":"",mset[i]);fflush(0);*/
     assert(S->Nspl<EQUA_Nmax); assert(nb <= S->Fa-S->Fp); S->Fp+=nb;
     for(i=0;i<cd;i++) Upos[i]=(UC)mset[i];     /* put {mset ne np net Eq[]} */
     for(i=0;i<E->ne;i++)Eq[i]=E->e[i]; L[0]=E->ne; L[1]=np; L[2]=net;
     for(i=0;i<S->Fnum[cd];i++)		       /* search sorted (&mset)-list */
     {	int LmR=LmR_mset(cd,Upos,S->Fspl[S->Foff[cd]+i]); assert(LmR);
        if(LmR<0) break;
     }  
     for(j=S->Nspl;j>S->Foff[cd]+i;j--) S->Fspl[j]=S->Fspl[j-1];   /* insert */
/*printf("] at j%d=i%d+o%d i<n%d\n",j,i,S->Foff[cd],S->Fnum[cd]);fflush(0);*/
     S->Fspl[j]=Upos; S->Fnum[cd]++; 		
     S->Nspl++; for(i=cd+1;i<=CD_Nmax;i++) S->Foff[i]++;	return Eq;
}
int  Find_Norm_CHP(SymData *S,int cd,int *mset,int *ne,Equation *Eq)
{    int i,j, *L; UC ucms[CD_Nmax]; for(i=0;i<cd;i++)ucms[i]=mset[i];
printf(" Get(%d) [",S->Fnum[cd]);
for(i=0;i<cd;i++)printf("%s%d",i?" ":"",mset[i]);printf("]");fflush(0);
     if(0==S->Fnum[cd]) return 0;
     for(i=0;i<S->Fnum[cd];i++)		       /* search sorted (&mset)-list */
     {	UC *uci=S->Fspl[S->Foff[cd]+i];int LmR=LmR_mset(cd,ucms,uci);if(LmR==0)
	{   int *L=(int *)&uci[cd]; Eq=(Equation *) &L[3]; *ne=L[0];
printf(" found Eq: NE=%d np=%d\n",L[0],L[1]);fflush(0);
	    return *ne;
	}   if(LmR<0) return 0;
     }  return 0;
}

/*		M A K E  n o r m a l i z e d CHPs			*
 *	reduced PPL X; span ?; Find / Get / Put equations		*
 *		write normalized EqList to S.Fli (Fp Fa Fnum Foff Fspl) *
 *	make CHPs and complete poly by going through cd2f / NeFa flags	*
 */
int  Make_Norm_CHP_Eqs(PolyPointList *P, int cd, int *mset, SymData *S, 
		       int *ST, int ns, int *ne, Equation *Eq)	 /* = span? */
{    int net=0, i,j, x=0, a[POLY_Dmax], p[POLY_Dmax],STinv[POLY_Dmax]; 
     VertexNumList V; EqList *E; PolyPointList *X;
     X = (PolyPointList *) malloc(sizeof(PolyPointList)+sizeof(EqList));
     assert(X != NULL); E=(EqList *) &X[1]; X->n=P->n-cd; 
     for(i=0;i<P->n;i++) STinv[S->CL[ST[0]].L[i]]=i;
     for(j=0;j<cd;j++)while(x<mset[j]-j)a[x]=j+x++;while(x<X->n)a[x]=j+x++;
     Make_CHP_PPL(P,cd,mset,a,X); GLZ_Start_Simplex(X,&V,(CEqList *)E);

printf(" -> %d ",X->np);/*for(i=0;i<cd;i++)printf(" %2d",mset[i]);*/
if(E->ne<X->n)printf("NoFace: ne=%d \n",E->ne);else puts("span");

     if(E->ne<X->n) {free(X);return 0;}				/* span? */
     if(X->np<=VERT_Nmax) { S->FE++; 
	if(!COUNT_ONLY) {Find_Equations(X,&V,E); Check_EqList(E,X);}}
     else
     {	int ainv[POLY_Dmax]; S->FC++;
	for(x=0;x<X->n;x++){p[x]=STinv[a[x]];ainv[a[x]]=x;}
{int id[POLY_Dmax]; for(i=0;i<cd;i++)id[i]=mset[i]; /* test map: x -> p */
for(x=0;x<X->n;x++)id[cd+x]=a[x];
for(i=1;i<P->n;i++)for(j=i;j<P->n;j++)if(id[i-1]>id[j])swap(&id[i-1],&id[j]);
for(i=0;i<P->n;i++)if(id[i]!=i){puts("error");exit(0);}}
	for(x=0;x<X->n;x++)					/* make CHPs */
	{   for(i=1;i<ns;i++) if(S->CL[ST[i]].L[p[x]] < a[x]) break; 
	    if(S->CL[ST[0]].L[p[x]] != a[x]){puts("error in a[x]");exit(0);}
	    if(i<ns) continue; S->omit[cd]=p[x];

if(cd<CD_Nmax)
{printf("H%2d:  cd=%d ns=%2d  np: %3d ",p[x],cd,ns,X->np);
fflush(0);
	    net=CHP_Equations(P,S,cd+1,E); 
}		/* else {puts("increase CD_Nmax");exit(0);} */

	/* put norm/min on EqList; NeighbourFacet-flag */
	}
     }	Eq=Put_Norm_CHP(E,S,cd,mset,X->np,net); free(X);return 1;
}

void Back_Transform(Equation *Eq,int ne,int cd,int ns,int *ST,SymData *S, 
     EqList *E)
{return; puts("implement Back_Transform");exit(0);}	/* ?????????????? */

/*	M A K E  CHPs	u s i n g   n o r m a l i z e d   o n e s	*
 *	compute list of inequivalent equations -> EqList, 		*
 *	input: PPL, SymData, codim	output: EqList			*/
int  CHP_Equations(PolyPointList *P,SymData *S,int cd,EqList *E)
{    int mset[CD_Nmax+1], ST[SYM_Nmax], ns, ne; Equation *Eq;
     ns=Norm_Omit(cd,mset,ST,S); 
     if(!Find_Norm_CHP(S,cd,mset,&ne,Eq))
     {	if(!Make_Norm_CHP_Eqs(P,cd,mset,S,ST,ns,&ne,Eq)) return 0; /* span? */
     }	Back_Transform(Eq,ne,cd,ns,ST,S, E); 		 return ne;
}
int  Start_CHP_Equations(PolyPointList *P,EqList *E) /* return ne-tot */
{    int eqtot=0; SymData S; assert(P->np<=UNM); assert(P->np<=EQUA_Nmax); 
     assert(NULL != (S.CL=(PERM *)malloc(SYM_Nmax*sizeof(PERM))));
     InitSymData(&S,&P->n); Make_Symmetries(P,S.CL,&S.ns);
     CHP_Equations(P,&S,0,E); printf("Faces: %d (%d FE)\n",S.FE+S.FC,S.FE); 
     FreeSymData(&S); return eqtot;
}
