/*  ======================================================================  */
/*  ========== Use of crewei: crewei >file           =====================  */
/*  ======================================================================  */
#include <stdio.h>
#include <string.h>
#define  N         4 
#define  lint      long
#define  sint      short
#define  WDIM      300000
#define  INFO      0

typedef struct {lint num; lint den;} rat;
typedef struct {int n[N+1];} weights;
typedef rat ratmat[N][N];
typedef rat ratvec[N];
int points[N][N];
int subsets[N-1][10][N];
int nsubsets[N-1];
int wnum=1;
weights wli[WDIM];


/*  ======================================================================  */
/*  ==========             integer and rational stuff           ==========  */
/*  ======================================================================  */
#define  mod(a,b)  ((a)%(b))  
#define  MOD(a,b)  ((b) ? mod(a,b) : (a))  
#define  min(a,b)  (((a)<(b)) ? (a) : (b))
#define  max(a,b)  (((a)>(b)) ? (a) : (b))
#define  lcm(a,b)  ((a)*(b)/gcd((a),(b)))
#define  abs(a)    (((a)<0) ? (-(a)) : (a))

lint  gcd(lint a, lint b); /* modulus of greatest common div.; gcd(0,n)=|n| */
rat   rI(lint a);          /*  conversion  lint -> rat                      */
rat   rR(lint a, lint b);  /*  conversion  a/b  -> rat                      */
rat   rS(rat a, rat b);    /*  a + b                                        */
rat   rD(rat a, rat b);    /*  a - b                                        */
rat   rP(rat a, rat b);    /*  a * b                                        */
rat   rQ(rat a, rat b);    /*  a / b                                        */
void  fS(rat *a, rat *b);  /*  fast sum: add rat  *b  to rat  *a            */
void  iS(rat *a, int *b);  /*  fast sum: add int  *b  to rat  *a            */
rat   rI(register lint a) {rat c; c.num=a; c.den=1; return c; }    /*  a/1  */
rat   rR(register lint a, register lint b)                         /*  a/b  */
{     register lint g=gcd(a,b); rat c; g=(b<0) ? -g:g; c.num=a/g;c.den=b/g;
      return c;
}
rat   rS(rat a, rat b)                                           /*  a + b  */
{     register rat c; register lint g=gcd(a.den,b.den);
      g=gcd(c.den=a.den*(b.den/g),c.num=a.num*(b.den/g)+b.num*(a.den/g));
      c.num/=g; c.den/=g; return c;
}
rat   rD(rat a, rat b)                                           /*  a - b  */
{     register rat c; register lint g=gcd(a.den,b.den);
      g=gcd(c.den=a.den*(b.den/g),c.num=a.num*(b.den/g)-b.num*(a.den/g));
      c.num/=g; c.den/=g; return c;
/**      register rat c; register lint g=gcd(c.num=a.num*b.den-b.num*a.den,
                     c.den=a.den*b.den);      c.num/=g; c.den/=g; return c; */
}
rat   rP(rat a, rat b)                                           /*  a * b  */
{     register lint g=gcd(a.num,b.den); register lint h=gcd(b.num,a.den);
      register rat c; c.num=(a.num/g)*(b.num/h); c.den=(a.den/h)*(b.den/g);
      return c;
}
rat   rQ(rat a, rat b)                                           /*  a / b  */
{     register lint g=gcd(a.num,b.num); register lint h=gcd(b.den,a.den);
      register rat c; c.num=(a.num/g)*(b.den/h); c.den=(a.den/h)*(b.num/g);
#ifdef TEST
    if (!c.den)
    fprintf(outfi,"warning: vanishing denominator in rQ in %s!\n",infun);
#endif
      if (c.den<0) {c.num=-c.num; c.den=-c.den;} return c;
}
lint  gcd(register lint a, register lint b)
{     a = (a<0) ? -a:a; b = (b<0) ? -b:b; if (!a) return b; if (!b) return a;
       {register lint c;  while(c=mod(a,b))  {a=b;b=c;} return  b;}
}
lint  argint(char* s)                                  /* string to integer */
{     lint d=(*s)-'0'; sint i=1; while(s[i]) d=10*d+s[i++]-'0'; return d;
}
/* void  prat(rat a) {fprintf(outfi,"%ld/%ld ",a.num,a.den);}
/*  ======================================================================  */
/*  ==========          end of integer and rational stuff       ==========  */
/*  ======================================================================  */


/*  ==========             calculation of weights               ==========  */

sint weicomp(weights w1,weights w2) 
                                /* w2-w1, i.e. pos for w1<w2,neg for w1>w2  */
{    int i=N;
     while((i)&&(w1.n[i]==w2.n[i])) i--;  return w2.n[i]-w1.n[i];
}

void insertat(weights ww, int position)
{    int i, j;
     for(i=wnum-1;i>=position;i--)
       for(j=0;j<=N;j++) wli[i+1].n[j]=wli[i].n[j];
     for(j=0;j<=N;j++) wli[position].n[j]=ww.n[j];     wnum++;
}

void addweight(weights wn)
{    int i, p, n0, n1, k;
     if (wnum>=WDIM) {
       if(wnum>WDIM) return; 
       else {wnum++; printf("WDIM too small!\n");fflush(0);return;}}
     for(i=0;i<N-1;i++) for(p=i+1;p<N;p++) if (wn.n[i]>wn.n[p]) 
       {k=wn.n[i]; wn.n[i]=wn.n[p]; wn.n[p]=k;}  /* make n0<=n1<=...<=n# */
     if (wnum) {if (i = weicomp(wn,wli[n0=0]))
               {if (i>0) {insertat(wn,0); return;}} else return;
	    if (i = weicomp(wn,wli[n1=wnum-1]))
               {if (i<0) {insertat(wn,wnum); return;}} else return;
      while(n1>n0+1) {p=(n0+n1)/2; i=weicomp(wn,wli[p]);
                  if(i) {if(i>0) n1=p; else n0=p;} else return;}
      insertat(wn,n1);}
     else insertat(wn,0);
}

void writewei(weights ws){
  int i;
  for (i=0;i<=N;i++) printf("%d ",ws.n[i]);
	  printf("\n"); 
}

int checkwrite(weights ws){
  int i;
  for (i=0;i<N;i++) if (!ws.n[i]) return 0;
  addweight(ws);
  return 1;
}

weights testweisys(int npoints){
  weights tws;
  ratmat rm;
  ratvec newboundwei, boundwei[10], rattws, rs;
  int i, ii, j, k, nboundwei=0, new, rankrm, one[N];
  lint minnbw, maxnbw;
  for (k=0;k<nsubsets[npoints-2];k++   /* alle 0-systeme */ ){
    rankrm=0;
    for (i=0;i<npoints;i++){
      for (j=0;j<npoints;j++){
	rm[i][j]=rI(points[i][subsets[npoints-2][k][j]]);}
      rs[i]=rI(1);   }
    for (i=0;i<npoints;i++){
      one[i]=-1;
      for (j=0;(j<npoints)&&(one[i]<0);j++) if (rm[i][j].num) {
	one[i]=j;
	rankrm++;   }
      if (one[i]>=0){
	for (j=one[i]+1;j<npoints;j++) /* normalize i'th line */
	  rm[i][j]=rQ(rm[i][j],rm[i][one[i]]);
	rs[i]=rQ(rs[i],rm[i][one[i]]);
	rm[i][one[i]]=rI(1);
	for (ii=0;ii<npoints;ii++) if (ii-i){ /* subtract multiple of i'th
                    line from ii'th line */
	  for (j=0;j<npoints;j++) 
	    if (j!=one[i]) rm[ii][j]=rD(rm[ii][j],rP(rm[ii][one[i]],rm[i][j]));
	  rs[ii]=rD(rs[ii],rP(rm[ii][one[i]],rs[i]));
 	  rm[ii][one[i]]=rI(0);  }   }    }
    for (j=0;j<N;j++) newboundwei[j]=rI(0);
    if (rankrm==npoints) for (i=0;i<npoints;i++) 
      newboundwei[subsets[npoints-2][k][one[i]]]=rs[i];
    minnbw=0; 
    maxnbw=0; 
    for (j=0;j<N;j++) {
      minnbw=min(newboundwei[j].num,minnbw);
      maxnbw=max(newboundwei[j].num,maxnbw); }
    new=((minnbw>=0)&&(maxnbw>0));
    for (i=0;new&&(i<nboundwei);i++) {
      new=0; 
      for (j=0;j<N;j++) if (rD(newboundwei[j],boundwei[i][j]).num) new=1; }
    if (new) {
      for (j=0;j<N;j++) boundwei[nboundwei][j]=newboundwei[j]; 
      nboundwei++;    }   }
  for (j=0;j<N;j++) {
    rattws[j]=rI(0);
    for (i=0;i<nboundwei;i++) rattws[j]=rS(rattws[j],boundwei[i][j]);
    rattws[j]=rQ(rattws[j],rI(max(nboundwei,1)));}
  tws.n[N]=1;
  for (j=0;j<N;j++) tws.n[N]=lcm(tws.n[N],rattws[j].den);
  for (j=0;j<N;j++) tws.n[j]=rP(rI(tws.n[N]),rattws[j]).num;
  return tws;
}

void createweights(int npoints){
  int x0, x1, x2, x3, x4, sum, maxx;
  weights tws;
  tws=testweisys(npoints);
  if(checkwrite(tws)) if (npoints<N){
    for (x0=0;x0*tws.n[0]<tws.n[N];x0++)
    for (x1=0;x0*tws.n[0]+x1*tws.n[1]<tws.n[N];x1++)
    for (x2=0;x0*tws.n[0]+x1*tws.n[1]+x2*tws.n[2]<tws.n[N];x2++)
#if (N>3)    
    for (x3=0;x0*tws.n[0]+x1*tws.n[1]+x2*tws.n[2]+x3*tws.n[3]<tws.n[N];x3++)  
#endif
#if (N>4)    
    for (x4=0;x0*tws.n[0]+x1*tws.n[1]+x2*tws.n[2]+x3*tws.n[3]+
                                                  x4*tws.n[4]<tws.n[N];x4++)
#endif  
    { sum=0; maxx=0;
      points[npoints][0]=x0; sum+=x0; maxx=max(maxx,x0);
      points[npoints][1]=x1; sum+=x1; maxx=max(maxx,x1);
      points[npoints][2]=x2; sum+=x2; maxx=max(maxx,x2);
#if (N>3)    
      points[npoints][3]=x3; sum+=x3; maxx=max(maxx,x3);
#endif
#if (N>4)    
      points[npoints][4]=x4; sum+=x4; maxx=max(maxx,x4);
#endif  
      if ((sum>2)&&(maxx>1)) createweights(npoints+1);
      /* if (npoints<3) {printf("%d",npoints); fflush(0);}*/}  }
}

void makesubsets(){
  int i, p0,p1,p2,p3,p4;
  for (i=0;i<N-1;i++) nsubsets[i]=0;
  for (p0=0;p0<N-1;p0++) for (p1=p0+1;p1<N;p1++) {
    subsets[0][nsubsets[0]][0]=p0; 
    subsets[0][nsubsets[0]][1]=p1;
    nsubsets[0]++;
    for (p2=p1+1;p2<N;p2++) {
      subsets[1][nsubsets[1]][0]=p0; 
      subsets[1][nsubsets[1]][1]=p1;
      subsets[1][nsubsets[1]][2]=p2;
      nsubsets[1]++;
      for (p3=p2+1;p3<N;p3++) {
	subsets[2][nsubsets[2]][0]=p0; 
	subsets[2][nsubsets[2]][1]=p1;
	subsets[2][nsubsets[2]][2]=p2;
	subsets[2][nsubsets[2]][3]=p3;
	nsubsets[2]++;
	for (p4=p3+1;p4<N;p4++) {
	  subsets[3][nsubsets[3]][0]=p0; 
	  subsets[3][nsubsets[3]][1]=p1;
	  subsets[3][nsubsets[3]][2]=p2;
	  subsets[3][nsubsets[3]][3]=p3;
	  subsets[3][nsubsets[3]][4]=p4;
	  nsubsets[3]++;  }  }  }  } 
}

main(){   /*  writes all allowed weights  */
  int i;
  makesubsets();
  for (i=0;i<N;i++) points[0][i]=1;
  for (i=0;i<N;i++) wli[0].n[i]=1;
  wli[0].n[N]=N;
#if (N>4)    
  points[1][0]=4; for (i=1;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (4,0,0,0,0)\n"); fflush(0); 
#endif
  points[1][0]=3; points[1][1]=1; for (i=2;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (3,1,0,0,0)\n"); fflush(0);
#endif         
  points[1][0]=2; points[1][1]=2; for (i=2;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (2,2,0,0,0)\n"); fflush(0);
#endif         
  points[1][0]=2; points[1][1]=1; points[1][2]=1; 
      for (i=3;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (2,1,1,0,0)\n"); fflush(0);
#endif         
#endif
#if (N>3)    
  points[1][0]=3; for (i=1;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (3,0,0,0,0)\n"); fflush(0);
#endif         
  points[1][0]=2; points[1][1]=1; for (i=2;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (2,1,0,0,0)\n"); fflush(0);
#endif         
#endif         
  points[1][0]=2; for (i=1;i<N;i++) points[1][i]=0;
  createweights(2);
#if INFO
  printf("Did (2,0,0,0,0)\n"); fflush(0);  
#endif         
  for (i=0;i<wnum;i++) writewei(wli[i]);
}




