#include "Global.h"
#include "Nef.h"
#include "LG.h"

#define REDUCE_L
#define REDUCE_VPM

#define IN_MORI
#define IN_MATH

#undef IN_MORI
/*#undef REDUCE_VPM*/

FILE *inFILE, *outFILE;

typedef struct { int v, d; Long **x;}                      Matrix;/* Line[v][d] */
typedef struct { Long x[POLY_Dmax][W_Nmax]; int N, n; }          AmbiLatticeBasis;
typedef struct { Long x[AMBI_Dmax][AMBI_Dmax]; int n, N; }       CWLatticeBasis;
typedef struct { int  x[VERT_Nmax]; int n;}                      PointList;
typedef struct { Long PNF[POLY_Dmax][VERT_Nmax];
	               int a, n, p, fib, d, f, vx, vy, l, t, index, S[VERT_Nmax];
	               int nl;
	               Weight *W;}                                     SplitInfo;

void Make_L(PolyPointList *_P, VertexNumList *_V, LInfo *_L , int p, int v);
int  Make_Poly_NF(PolyPointList *_P, VertexNumList *_V, EqList *_F,
									Long pNF[POLY_Dmax][VERT_Nmax])	;
Long V_to_G_GI(Long *V,int d, Long G[][POLY_Dmax],Long GI[][POLY_Dmax]);
int  Is_Gen_CY(int index, PolyPointList *P);
int Remove_Identical_Points(PolyPointList *);
int diff(const void *a, const void *b);
void Make_Poly_Points(Weight *_W_in, PolyPointList *_PP);
int Read_Weight(Weight *_W);     
void Make_Cone(Cone * _C_D, Cone * _C_N, FaceInfo * _I, PolyPointList * _P);
int Num_Pos(Cone *_C);
void Make_PosetList(Cone *_C, Poset_Element_List *_PEL);
void Make_Intervallist(Interval_List *_IL, Poset_Element_List *_PEL, Cone *_C);
void Make_B_Poly(Cone * _C, Poset_Element_List * _PEL, Interval_List * _IL,BPoly *_BL);
void Sort_PPL(PolyPointList *_P, VertexNumList *_V);
void SB_To_E(EPoly *_EP, Cone *_C, Poset_Element_List *_PEL, BPoly * _BL,
						 Interval_List * _IL, SPoly *_S_D, SPoly *_S_N, int *_codim);
void Make_PosetList(Cone *_C, Poset_Element_List *_PEL);
void PrintDiamond(int h[][POLY_Dmax], int dim);
void Make_S_Poly(Cone *_C, VertexNumList *_V, EqList *_E, PolyPointList *_P,
                 Poset_Element_List *_PEL, SPoly *_S, int SINFO, int CHECK_SERRE);
void Make_Gore_Poly(PolyPointList * _P, PolyPointList * _DP,
		    PolyPointList * _P_D, PolyPointList * _P_N,
		    VertexNumList * _V, PartList * _PTL, int *_codim, int *_n);
void Print_NF(FILE *F,int *d, int *v,Long NF[POLY_Dmax][VERT_Nmax])
{    int i,j; fprintf(F,"%d %d\n",*d,*v); for(i=0;i<*d;i++)
     for(j=0;j<*v;j++)fprintf(F,"%d%s",(int)NF[i][j],(*v==j+1) ? "\n" : " ");
}

void  PrintUsage(char *c){
#define	PUli	5
#define	PUitems	2*PUli
	int i; char opt_string[PUitems][40]={
  "h  print this information              ",
  "f  use as filter                       ",
	"s  no hodge calculation                ",
	"L  print split poly + nef info + L info",
	"P  print split poly                    ",
	"p  print input (gen) poly              ",
	"p  print input (gen) poly + weights    ",
	"d  print dual (M) input (gen) poly     ",	
	"t  show transformatios for split       ",
	"r  print index x input poly            "
	};

  printf("This is ``%s'':  computing data of a polytope P\n",c);
  printf("Usage:   %s [-<Option-string>] [in-file [out-file]]\n", c);
  printf("Options (concatenate any number of them into <Option-string>):\n");
  for (i=0;i<PUli;i++) printf("  %s | %s\n",opt_string[i],opt_string[i+PUli]);
  puts("Input:    degrees and weights `d1 w11 w12 ... d2 w21 w22 ...'");
  puts("          or `d np' or `np d' (d=Dimension, np=#[points]) and");
  puts("              (after newline) np*d coordinates");
  puts("Output:   as specified by options");
}

void PrintXUsage(char *c){
#define	XPUli	5
#define	XPUitems	2*XPUli
	int i; char opt_string[XPUitems][45]={	
  "x  print this information                  ",
  "W  print Weight if poly has full dimension ",
	"r  print r x input-poly (r=index)          ",
	"                                           ",
	"                                           ",
	"c[r] (needs points in N-lattice as input): ",	
  "        print poly if it has diff.   splits",
	"     s  print poly if it splits            ",
	"     m  print poly if it has mult. splits  ",
	"     a  print all different splits         "
	};puts("Testing options:    ");	
	for (i=0;i<XPUli;i++) printf("  %s | %s\n",opt_string[i],opt_string[i+XPUli]);
}

void sort(int f[], int cd){
	qsort(f, cd, sizeof(int), &diff);
}

void COmplete_Poly(EqList *E, VertexNumList *V, PolyPointList *P)
{
	Long X[EQUA_Nmax][VERT_Nmax];
	Make_VEPM(P,V,E,X);
	Complete_Poly(X, E, V->nv, P);
}

int MAKE_h(EPoly *_EP, int h[][POLY_Dmax], int D, int dim){
	int u, v, chi = 0;

  for (u = 0; u < 4*(Pos_Max); u++)
    for (v = 0; v < 3*(Pos_Max); v++){
      if(((-2 * D + u) > dim) || ((-2 * D + u) < 0) ||
				 ((-2 * D + v) > dim) || ((-2 * D + v) < 0)){
				if (_EP->E[u][v] != 0)
				{Die("Something	 wrong with E poly");}
      }
      else {
				h[(u - 2*D)][v - 2*D] = _EP->E[u][v];
				chi += _EP->E[u][v];
				if(((u - 2*D + v - 2*D) %2 ) != 0)
					h[(u - 2*D)][v - 2*D] *= -1;
      }
    }
  if((dim %2) == 0) chi = chi*(-1);
  return chi;
}

void Make_PEV_N(PolyPointList *P1, PolyPointList *P, EqList *E1, EqList *E,
							 VertexNumList *V1, VertexNumList *V, int index){
	Long *M=P->x[P->np], m[POLY_Dmax], k;
	PolyPointList *AP = NULL;
	Long G[POLY_Dmax][POLY_Dmax], GI[POLY_Dmax][POLY_Dmax];
	int i,j,l,TEST=1;
	/*E to AP;(cone!)*/
	AP = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (AP == NULL) Die("Unable to allocate space for AP");
	assert(POLY_Dmax > P->n);
	for(i=0;i<E->ne;i++){
		AP->x[i][0]=E->e[i].c;
		for(j=0;j<P->n;j++) AP->x[i][j+1]=E->e[i].a[j];
	}
	AP->n=P->n+1; AP->np=E->ne;
	/*transform AP to 10000xP1; (poly!)*/
	for(j=0;j<P->n;j++) m[j+1] = M[j]; m[0] = index;
	V_to_G_GI(m,AP->n, G, GI);
	for(i=0;i<E->ne;i++){for(j=0;j<AP->n;j++){
			k=0; for(l=0;l<AP->n;l++) k+=GI[l][j]*AP->x[i][l];
			if(j==0){assert(k==1);}else P1->x[i][j-1] = k;
		}
	}
	P1->n=P->n; P1->np=E->ne;
  /*Vertices of P1 are E; equations are 1xV transformed with GI transposed to cxa*/
	V1->nv=E->ne;
	for(i=0;i<E->ne;i++) V1->v[i] = i;
	for(i=0;i<V->nv;i++){
		E1->e[i].c=G[0][0];
		for(l=0;l<P->n;l++)E1->e[i].c+=G[0][l+1]*P->x[V->v[i]][l];
		for(j=0;j<P->n;j++){
			E1->e[i].a[j] = G[j+1][0];
			for(l=0;l<P->n;l++) E1->e[i].a[j]+=G[j+1][l+1]*P->x[V->v[i]][l];
		}
	}
	E1->ne=V->nv;
	/*check if VEPM is the same after transformation*/
	if(TEST){
		Long X[EQUA_Nmax][VERT_Nmax], Y[EQUA_Nmax][VERT_Nmax];
		Make_VEPM(P,V,E,X);
		Make_VEPM(P1,V1,E1,Y);
		for(i=0;i<E->ne;i++) for(j=0;j<V->nv;j++) assert(X[i][j]==Y[j][i]);	
	}
	free(AP);
	/*calculate n in new basis and put it at the and of P1*/
	COmplete_Poly(E1, V1, P1);Sort_PPL(P1, V1);assert(P1->np<POINT_Nmax);
	for(i=0;i<P->n;i++) P1->x[P1->np][i]=GI[0][i+1]; assert(GI[0][0]==index);
}

void Print_Weight(Weight *W)
{    int n; fprintf(outFILE,"%d",(int) W->d);
     for(n=0; n < W->N; n++) fprintf(outFILE," %d",(int) W->w[n]);
#if  WZinput
     {  int i,j; if(W->M>0)printf(" "); for(i=0;i<W->M;i++)
        {  fprintf(outFILE,"/Z%d: ",W->m[i]);
           for(j=0;j<W->N;j++) fprintf(outFILE,"%d ",W->z[i][j]);
        }
     }
#endif
     /* puts("  = d  w_1 ... w_N"); */
}

void OUT(Weight *W, int index, int split, int fib, int p, int v, int pm, int vm,
				 int nl)
{
	Print_Weight(W);/*Write_Weight(W);*/
	fprintf(outFILE, "I:%d ",index);
	if(split==1) fprintf(outFILE,"s ");
	if(fib==1) fprintf(outFILE,"f ");
	if(split > 1) fprintf(outFILE,"S! ");
	if(!nl) fprintf(outFILE,"nl ");
	fprintf(outFILE,"N:%d %d M:%d %d ",p,v,pm,vm);fflush(0);
}

void shift_h(int hgen[POLY_Dmax][POLY_Dmax], int h[POLY_Dmax][POLY_Dmax],
						 int dim, int diff){
	int i,j;

	for(i=diff;i<=dim-diff;i++)
		for(j=diff;j<=dim-diff;j++)h[i-diff][j-diff]=hgen[i][j];
	for(i=0;i<diff;i++)for(j=0;j<=dim;j++){
		assert(hgen[i][j]==0); assert(hgen[j][i]==0);} 
	for(i=(dim-diff+1);i<=dim;i++)for(j=0;j<=dim;j++){
		assert(hgen[i][j]==0); assert(hgen[j][i]==0);}
}

void OUT_HODGE(int hgen[POLY_Dmax][POLY_Dmax], int dim, int H, int chi, int diff)
{
	int i,h[POLY_Dmax][POLY_Dmax];
	shift_h(hgen,h,dim,diff);
	if(H) PrintDiamond(h, (dim-2*diff));
	else{
		dim=dim-2*diff;
		fprintf(outFILE, "H:");
		for (i = 1; i < dim; i++) fprintf(outFILE, "%d ", h[1][i]);
		fprintf(outFILE, "[%d] ",chi);
		for (i = 1; i <=  dim/2; i++)
	  if (h[0][i] != 0)
	    fprintf(outFILE, " h%d=%d", i, h[0][i]);
		if(h[0][0] != 1) fprintf(outFILE, " h%d=%d", 0, h[0][0]);fflush(0);
	}
}

int CHECK_HODGE(int h[POLY_Dmax][POLY_Dmax],Weight *W)
{
	return 1;
}

/*	##################			BEGIN MATRIX:		##################	*/

void Print_LMatrix(Matrix M, char *s){int i,j;
  fprintf(outFILE,"%d %d LV %s\n",M.v,M.d,s); for(i=0;i<M.v;i++){ for(j=0;
    j<M.d;j++) fprintf(outFILE,"%2d%s",(int) M.x[i][j],(j+1==M.d) ? "\n" : " ");}}

void Print_CMatrix(Matrix M, char *s){int i,j;
  fprintf(outFILE,"%d %d CV %s\n",M.d,M.v,s); for(i=0;i<M.d;i++){ for(j=0;
    j<M.v;j++)fprintf(outFILE,"%2d%s",(int) M.x[j][i],(j+1==M.v) ? "\n" : " ");}}

void  Init_Matrix(Matrix *M,int v, int d){               /* v=#vec, d=dim */
  int i; M->x=(Long **) malloc (v*(sizeof(Long *)+d*sizeof(Long)));
  assert(M->x != NULL); M->d=d; M->v=v;
  M->x[0]=(Long *)(&(M->x[v])); for(i=1;i<v;i++) M->x[i]=&M->x[i-1][d];}

void Free_Matrix(Matrix *M){free(M->x);M->v=M->d=0;}

void COPY_MATRIX(Matrix *A, Matrix *B){
	int i,j;
	for(i=0;i<A->v;i++)for(j=0;j<A->d;j++) B->x[i][j]=A->x[i][j];
	B->d=A->d;B->v=A->v;
}

void GxMATRIX(Long G[POLY_Dmax][POLY_Dmax], Matrix *X){

	Matrix A; 
	int v,d,i;
	Init_Matrix(&A, X->v, X->d);
	COPY_MATRIX(X,&A);
	for(v=0;v<A.v;v++)for(d=0;d<A.d;d++){
		X->x[v][d]=0;
		for(i=0;i<X->d;i++) X->x[v][d]+=G[d][i]*A.x[v][i];
	}	
	Free_Matrix(&A);
}

void E_MATRIX(Matrix *X){
	int i,j;
	assert(X->v==X->d);
	for(i=0;i<X->v;i++)for(j=0;j<X->d;j++){if(j==i)X->x[i][j]=1;else X->x[i][j]=0;}
}

int IP(Long *x, Long *y, int dim){
	Long K=0; while(dim--){K+=x[dim]*y[dim];}return K;
}

void MATRIX_PM(Matrix *X, Matrix *Y, int S[], int cd, FILE *MATH_FILE){

	int i,j;
	/*fprintf(MATH_FILE,"\nVPM:\n");*/
	/*for(j=0;j<X->v;j++) fprintf(outFILE,"%2d ",S[j]); fprintf(outFILE,"\n");  
		for(j=0;j<X->v;j++) fprintf(outFILE,"---");fprintf(outFILE,"\n");*/
	for(i=0;i<Y->v;i++){
		for(j=0;j<X->v;j++)
			if(S[j])fprintf(MATH_FILE,"%2d ",(int) IP(X->x[j],Y->x[i],X->d));
		for(j=X->v-cd;j<X->v;j++)
			fprintf(MATH_FILE,"%2d%s",(int) IP(X->x[j],Y->x[i],X->d),(j+1==X->v)?"\n" : " ");
	}
}

/*	##################			END   MATRIX:		##################	*/

/*	##################			BEGIN SPLIT:		##################	*/

int V_Equal(Long *x, Long *y, int dim){
	while(dim--){if (y[dim] != x[dim]) return 0;}
	return 1;
}

int Make_Last_Point(Matrix *E, Matrix *X, int e[POLY_Dmax])
{
	int i,j,np,found;
	Long  N[POLY_Dmax];
	
	for(j=0;j<X->d;j++) N[j]=X->x[X->v][j];
	for(i=0;i<E->d;i++) E->x[E->v][i]=N[i];
	for(i=0;i<E->v;i++) for(j=0;j<E->d;j++) E->x[E->v][j]-=E->x[i][j];
	E->v++;
	np=0;found=0;
	while((np<X->v) && (!found)){
		if(V_Equal(X->x[np],E->x[E->v-1],X->d)){
				found=1; e[E->v-1]=np;
			}
		np++;
	}
	return(found);
}

void Make_E(Matrix *E, Matrix *X, int e[], int n)
{
	int i,j;
	for(i=0;i<n;i++)for(j=0;j<X->d;j++)E->x[i][j]=X->x[e[i]][j];
	E->d=X->d; E->v=n;
}


void Sort_X(Matrix *X, Matrix *AX, int e[], int cd){
	int i,j,ne=0;
	AX->v=0; AX->d=X->d; 
	for(i=0;i<X->v;i++){
		if(e[ne]!=i){for(j=0;j<X->d;j++) AX->x[AX->v][j]=X->x[i][j];AX->v++;}
		else(ne++);
	}
	assert(ne==cd);
	for(i=0;i<ne;i++)for(j=0;j<X->d;j++) AX->x[AX->v+i][j]=X->x[e[i]][j];
	AX->v+=cd; 	assert(AX->v==X->v);
}

int Poly_NF_EQUAL(Long pNF1[POLY_Dmax][VERT_Nmax],Long pNF2[POLY_Dmax][VERT_Nmax],
									int nv,int dim){
	int i,j;

	for(i=0;i<dim;i++) for(j=0;j<nv;j++) if(pNF1[i][j] != pNF2[i][j]) return 0;
	return 1;
}

void NefInfo(Matrix *X, int cd, int S[VERT_Nmax]){

	int i,j,k;
	
	assert(X->v < VERT_Nmax);
	for(j=0;j<X->v;j++){
		k=0;i=0;
		while((!k) && (i < cd)){
			if(X->x[j][i]){k=1; S[j]=i;} 
			i++;
		}
	}
}

void PrintL(LInfo *_L, int p, int v)
{
  int codim, D, i, j, N;

  if(v && p) Die("only -Lp OR -Lv !");

  N = (v ? _L->nv : (_L->nv + 1));
  
	assert(FIB_POINT_Nmax >= N);
	if(v) fprintf(outFILE,"%d %d Vertices in N-lattice:\n",_L->d, N);
	if(p) fprintf(outFILE,"%d %d Points in N-lattice:\n",_L->d, N);
	for(j = 0; j < _L->d; j++){
		for(i = 0; i < N; i++)	
			fprintf(outFILE,(_L->nv > 20) ? " %3d" : " %4d", (int) _L->VM[i][j]);
		fprintf(outFILE,"\n");
	}
  for(j = 0; j < N; j++)
    fprintf(outFILE,(_L->nv > 20) ? "----" :"-----");
  fprintf(outFILE,"\n");
  assert(FIB_Nmax >= _L->nw); assert(FIB_POINT_Nmax >= _L->nv);
  for(i = 0; i < _L->nw; i++){
    D = 0; codim = 0;
    for(j = 0; j < _L->nv; j++){
      D +=  _L->W[i][j];
      if(_L->W[i][j] == 0) 
				codim++;
    }
    for(j = 0; j < _L->nv; j++)
      fprintf(outFILE,(N > 20) ? " %3d" : " %4d",(int) _L->W[i][j]);    
    fprintf(outFILE,"  d=%d  ",D);
    fprintf(outFILE,"codim=%d\n",codim+_L->d-_L->nv+1);
  }
}
void PrintNEF(SplitInfo *SI, int S[VERT_Nmax], LInfo *L, int N, int cd){
	int i,j,k,l,n,D;
	
	/*for(k=0;k<cd;k++){D=0;for(j=0;j<N;j++)if(S[j]==k)D+=SI->S[j];assert(D==SI->d);}*/
	fprintf(outFILE,"\n");
	for(j = 0; j < N; j++) fprintf(outFILE,(N > 20) ? " %3d" : " %4d",S[j]);
	for(i=0;i<L->nw;i++){
		fprintf(outFILE," (");
		for(k=0;k<cd;k++){l=0;for(n=0;n<N;n++)if((S[n]==k)) l+=L->W[i][n];
		fprintf(outFILE,"%d", l); if(k!=(cd-1))fprintf(outFILE,",");
		}
		fprintf(outFILE,")");
	}
	fprintf(outFILE,"\n");
	for(j = 0; j < N; j++) fprintf(outFILE,(N > 20) ? " %3d" : " %4d",SI->S[j]);	
	fprintf(outFILE,"\n");
	for(j = 0; j < N; j++) fprintf(outFILE,(N > 20) ? "----" :"-----");
	fprintf(outFILE,"\n");
}

int Check_Ambi_Prod(LInfo *L, SplitInfo *SI, int cd){
	int i,j,k,l[POLY_Dmax],n=0,dirprod=1;
	
	for(i=0;i<L->nw;i++){
		j=0;k=1;
		while((j<L->nv) && k){
			if((SI->S[j]==0) && (L->W[i][j]!=0)) k=0;
			j++;
		}
		if(k){assert(n<POLY_Dmax); l[n++]=i;}
	}
	/*assert(n==cd);*/
	if(n<cd) SI->nl=0;
	for(j=0;j<L->nv;j++){
		k=0;
		for(i=0;i<n;i++){if(L->W[l[i]][j]!=0) k++;}
		if(k>1){dirprod=0; break;} ;
	}
#ifdef REDUCE_L
	for(i=0;i<n;i++) for(j=0;j<L->nv;j++) L->W[i][j]=L->W[l[i]][j];
	L->nw=n;
#endif	
	
	return(dirprod);
}

void in_MORI(Matrix *AX, Matrix *AY, SplitInfo *SI, int cd)
{
	Matrix B;
	int i,j;
	FILE *TOPCOM_FILE=NULL, *MORI_FILE=NULL;
	char command[MAXSTRING];
	
	Init_Matrix(&B, AX->v, AX->d-cd);
	B.d=AX->d-cd; B.v=AX->v-cd+1;
	/* (0,0,...,0) first
	for(i=0;i<AX->v-cd;i++) for(j=cd;j<AX->d;j++) B.x[i][j-cd]=AX->x[i][j];
	for(j=cd;j<AX->d;j++) B.x[AX->v-cd][j-cd]=AX->x[AX->v-1][j];
	*/
	for(i=0;i<AX->v-cd;i++) for(j=cd;j<AX->d;j++) B.x[i+1][j-cd]=AX->x[i][j];
	for(j=cd;j<AX->d;j++) B.x[0][j-cd]=AX->x[AX->v-1][j];

  /*write topcom.in*/
	TOPCOM_FILE=fopen("/tmp/triang.in","w"); assert(NULL!=TOPCOM_FILE);
	fprintf(TOPCOM_FILE,"\n[");
	for(i=0;i<B.v;i++){
		fprintf(TOPCOM_FILE,"[1"); 
		for(j=0;j<B.d;j++) fprintf(TOPCOM_FILE,",%d ",(int) B.x[i][j]);
		fprintf(TOPCOM_FILE,"]");
		if(i<(B.v-1)) fprintf(TOPCOM_FILE," , ");
	}
	fprintf(TOPCOM_FILE,"]\n");
	fclose(TOPCOM_FILE);
	
  /*write mori.in*/
	MORI_FILE=fopen("/tmp/mori.in","w"); assert(NULL!=MORI_FILE);
	fprintf(MORI_FILE,"%d %d\n",B.d,B.v);
	for(i=0;i<B.d;i++){for(j=0;j<B.v;j++)
		fprintf(MORI_FILE,"%2d%s", (int) B.x[j][i], (j+1==B.v) ? "\n" : " ");}
	fclose(MORI_FILE);
	/*complete mori.in*/
	sprintf(command,
					"cat /tmp/triang.in | points2finetriangs | find_star.pl >> /tmp/mori.in");
	system(command);
	Free_Matrix(&B);
	
}

void in_MATH(Matrix *AX, Matrix *AY, SplitInfo *SI, int cd){
	FILE *MATH_FILE;
	MATH_FILE=fopen("/tmp/math.in","w"); assert(NULL!=MATH_FILE);
	{
#ifdef REDUCE_VPM	
		int py=AY->v; AY->v=SI->vy;
#endif 		
	  MATRIX_PM(AX, AY, SI->S, cd, MATH_FILE);
#ifdef REDUCE_VPM	
		AY->v=py;
#endif
	}
	fclose(MATH_FILE);
}

void Check_Nef(Matrix *X, Matrix *Y, int cd, SplitInfo *SI)
{
	int i,j;
	PolyPointList *P = NULL;
  EqList *E = NULL;
	VertexNumList *V = NULL;
	LInfo L;
	
	P = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (P == NULL) Die("Unable to allocate space for P");
	V = (VertexNumList *) malloc(sizeof(VertexNumList));
	if (V == NULL) Die("Unable to alloc space for VertexNumList V");
	E = (EqList *) malloc(sizeof(EqList));
	if (E == NULL) Die("Unable to alloc space for EqList E");

	P->np=(X->v-cd+1);P->n=(X->d-cd);
	for(i=0;i<P->np;i++) for(j=0;j<P->n;j++)P->x[i][j]=X->x[i][j+cd];
	Find_Equations(P, V, E);
	assert(Ref_Check(P,V,E));/*Print_PPL(P,"Points of P");*/
	if(!SI->n){
		SI->n++;assert(Make_Poly_NF(P, V, E, SI->PNF));
		if (SI->l || SI->fib){
			int v=0,p=1, N=0,S[VERT_Nmax];
			if(v) N=V->nv; if(p) N=P->np;
			NefInfo(X, cd, S);
			Make_L(P, V, &L ,p,v);
			if(SI->fib){ if(!Check_Ambi_Prod(&L,SI,cd)) SI->f=1;}
			if(SI->l){
				PrintNEF(SI,S,&L,N-1,cd);
				PrintL(&L,p,v);
			}
		}
		if (SI->p && (!SI->l)){Print_PPL(P,"Points of P");}
		if (SI->a) Print_CMatrix(*X,"Partition in N-lattice:");
#ifdef IN_MORI			
		in_MORI(X,Y,SI,cd);
#endif
#ifdef IN_MATH			
		in_MATH(X,Y,SI,cd);
#endif	
	}
	else{
		Long pNF[POLY_Dmax][VERT_Nmax];
		assert(Make_Poly_NF(P, V, E, pNF));
		if (!Poly_NF_EQUAL(SI->PNF,pNF,V->nv,P->n)){
			SI->n++;
			if(SI->a)Print_CMatrix(*X,"Partition in N-lattice:");
		}
		/*if((SI->n>1)&& SI->fib){
			assert(Check_Ambi_Prod(&L,SI,cd) == !SI->f);}*/
	}
	free(E);free(V);free(P);
}

void WeightToDualPoints(Weight *W, Matrix *X, int S[], int index)
{
	int i,j,k,np,dim=X->d,foundDP;
	Long a[POLY_Dmax], b[POLY_Dmax];
	Long G[POLY_Dmax][POLY_Dmax], GI[POLY_Dmax][POLY_Dmax];
	
	assert(dim <= POLY_Dmax);  assert(X->v<VERT_Nmax);
	for(j=0;j<X->v;j++) S[j]=0;

	/*Print_LMatrix(*X,"dfdsfsd");
		for(j=1;j<dim;j++) printf(" %d ",W->rI[j-1]);*/
	
	for(j=1;j<dim;j++) b[j]=W->rI[j-1]; b[0]=index;
	V_to_G_GI(b,dim,G,GI);
	for(i=0;i<W->N;i++){
		for(j=1;j<dim;j++) a[j]=W->B[i][j-1];a[0]=W->A[i];
		foundDP=0;np=0;
		while(!foundDP && np < X->v){
			for(j=0;j<dim;j++){b[j]=0;for(k=0;k<dim;k++)b[j]+=G[k][j]*X->x[np][k];}
			if(V_Equal(a, b, dim)){foundDP=1;S[np]=W->w[i];}
			np++;
		}
		assert(foundDP);
	}
}

void Transform_XY(Matrix *X, Matrix *Y, int e[POLY_Dmax], int f[POLY_Dmax], int cd,
									SplitInfo *SI)
{
	int i,j,l,dim=X->d,TEST=1,DUAL=1,d, TRANSFORMATION=0, LM=0;
  Long G[POLY_Dmax][POLY_Dmax], GI[POLY_Dmax][POLY_Dmax],GIT[POLY_Dmax][POLY_Dmax];
	Long g[POLY_Dmax][POLY_Dmax], gI[POLY_Dmax][POLY_Dmax];
	Long x[POLY_Dmax];
	
	Matrix AY,AX,E,F,T,TIT;

	Init_Matrix(&E, 2*cd, X->d);
	Init_Matrix(&F, 2*cd, Y->d);
	Init_Matrix(&AX, X->v, X->d);
	Init_Matrix(&AY, Y->v, Y->d);
	Init_Matrix(&T, X->d, X->d); Init_Matrix(&TIT, X->d, X->d);
	Make_E(&E,X,e,(cd-1)); Make_E(&F,Y,f,(cd-1));
	
	assert(Make_Last_Point(&E,X,e));
	if((SI->t) && (!SI->n))  TRANSFORMATION=1; 
	
	if(TRANSFORMATION){ E_MATRIX(&T); E_MATRIX(&TIT);}
	if(e[E.v-1] > e[E.v-2]){
		if(Make_Last_Point(&F,Y,f)){
			if(TEST){
				Long k;
				for(i=0;i<E.v;i++) for(j=0;j<E.v;j++){
					k=IP(E.x[i],F.x[j],dim); if(i!=j) assert(k==0); if(i==j) assert(k==1);   
				}
			}
			if(LM){
				Print_LMatrix(E,"LM in N-lattice:");
				Print_LMatrix(F,"LM in M-lattice:");
			}
			Sort_X(X,&AX,e,cd);
			/*Print_LMatrix(*X,"Trans");WeightTo*/
			if(DUAL){ sort(f,cd);  Sort_X(Y,&AY,f,cd);}
			if(SI->l||SI->fib) WeightToDualPoints(SI->W, &AX, SI->S, SI->index);
			for(i=0;i<E.v;i++){
				d=(dim-i);
				for(j=0;j<d;j++) x[j]=E.x[i][j+i];
				if(TEST) for(j=0;j<i;j++) assert(E.x[i][j]==0);
				V_to_G_GI(x,d,g,gI);
				for(l=0;l<dim;l++)for(j=0;j<dim;j++){
					G[l][j]=GI[l][j]=0;
					if((l==j)&&(l<i)){G[l][j]=GI[l][j]=1;}
					if((l>=i)&&(j>=i)){G[l][j]=g[l-i][j-i]; GI[l][j]=gI[l-i][j-i];}
				}
				for(j=0;j<dim;j++)for(l=0;l<dim;l++)GIT[j][l]=GI[l][j];
				GxMATRIX(G,&AX);GxMATRIX(G,&E);GxMATRIX(GIT,&F);
				if(TRANSFORMATION){ GxMATRIX(G,&T); GxMATRIX(GIT,&TIT);}
				if(DUAL) GxMATRIX(GIT,&AY);
				for(l=0;l<dim;l++)for(j=0;j<dim;j++){
					G[l][j]=GI[l][j]=0; if(l==j){G[l][j]=GI[l][j]=1;}
				}
				assert(F.x[i][i]==1);
				for(j=i+1;j<dim;j++){G[i][j]=F.x[i][j];GI[i][j]=-F.x[i][j];} 	 	
				for(j=0;j<dim;j++)for(l=0;l<dim;l++)GIT[j][l]=GI[l][j];
				GxMATRIX(G,&AX);GxMATRIX(G,&E);GxMATRIX(GIT,&F);
				if(TRANSFORMATION){ GxMATRIX(G,&T);GxMATRIX(G,&TIT);}
				if(DUAL) GxMATRIX(GIT,&AY);
				/*if(TEST){printf("\n STEP %d:\n",i); Print_CMatrix(AX,"AX:");}*/
			}
			if(TRANSFORMATION){
				fprintf(outFILE,"\n nv: %d | mv: %d\n",SI->vx,SI->vy);
				Print_LMatrix(*Y,"Partition in M-lattice:");
				Print_LMatrix(*X,"Partition in N-lattice:");
				Print_LMatrix(AY,"Partition in M-lattice:");
				Print_LMatrix(AX,"Partition in N-lattice:");
				Print_CMatrix(T,"Transformation:");
				Print_CMatrix(TIT," Inverse Transposed Transformation:");
			}
			Check_Nef(&AX,&AY,cd,SI);
			Free_Matrix(&AX);Free_Matrix(&AY);Free_Matrix(&E);Free_Matrix(&F);
			Free_Matrix(&T);	Free_Matrix(&TIT);
		}
	}
}

void Complete_Y(Matrix *X, Matrix *Y, int vx)
{
	Long G[POLY_Dmax][POLY_Dmax], GI[POLY_Dmax][POLY_Dmax];
	Long n[POINT_Nmax],k;
	int i,j,l,dim=X->d;
	
	PolyPointList *AP = NULL;
  EqList *AE = NULL;
	VertexNumList *AV = NULL;
	
	AP = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (AP == NULL) Die("Unable to allocate space for AP");
	AV = (VertexNumList *) malloc(sizeof(VertexNumList));
	if (AV == NULL) Die("Unable to alloc space for VertexNumList AV");
	AE = (EqList *) malloc(sizeof(EqList));
	if (AE == NULL) Die("Unable to alloc space for EqList AE");
	AP->np=Y->v;	AP->n=(Y->d-1);
	for(j=0;j<dim;j++) n[j]=X->x[X->v][j];
	V_to_G_GI(n,dim,G,GI);
	for(i=0;i<Y->v;i++){for(j=0;j<Y->d;j++){
			k=0;for(l=0;l<dim;l++) k+=GI[l][j]*Y->x[i][l];
			if(j==0){assert(k==1);}else AP->x[i][j-1] = k;
	}}
	AV->nv=Y->v; AE->ne=vx;
	for(i=0;i<Y->v;i++) AV->v[i]=i; 
	for(i=0;i<vx;i++){
		AE->e[i].c=0;for(j=0;j<dim;j++) AE->e[i].c+=G[0][j]*X->x[i][j];
		for(j=0;j<dim-1;j++){
			AE->e[i].a[j]=0; for(l=0;l<dim;l++) AE->e[i].a[j]+=G[j+1][l]*X->x[i][l];
		}
	}
	COmplete_Poly(AE, AV, AP);
	for(i=0;i<AP->np;i++){
		for(j=0;j<dim;j++){
			k=G[0][j];for(l=1;l<dim;l++) k+=G[l][j]*AP->x[i][l-1];
			if(i<Y->v) assert(Y->x[i][j]==k);
			Y->x[i][j]=k;
		}
	}
	Y->v=AP->np;
	for(j=1;j<dim;j++) Y->x[Y->v][j]=0; Y->x[Y->v][0]=1;
	free(AE);free(AV);free(AP);
}

int Find_Candidates(Matrix *X, Matrix *Y, int vy, PointList *CX){
	int i,j,cand; Long ip;
	CX->n=0;
	for(i=0;i<X->v;i++){
		cand=1;j=0;
		while(cand && j< vy){
			ip=IP(X->x[i],Y->x[j],X->d);
			if(!((ip==0) || (ip==1))) cand=0;
			j++;
		}
		if(cand) CX->x[CX->n++]=i;
	}
	return CX->n;
}

void remove_from_SP(PointList *SP, int i, int *IPL, int vy,
										PointList *CX, Matrix *X,  Matrix *Y)
{
	int j;
	for(j=0;j<vy;j++){
		IPL[j]-=IP(Y->x[j],X->x[CX->x[i]],Y->d);assert(IPL[j]>=0);
	}
	SP->n--;
}

int add_to_SP(PointList *SP, int i, int *IPL, int vy,
							PointList *CX, Matrix *X,  Matrix *Y)
{
	int j=0,checkIP=1,TEST=0;
	while(checkIP && (j<vy)){
		if(IP(Y->x[j],X->x[CX->x[i]],Y->d) &&  IPL[j]) checkIP=0;
		j++;
	}
	if (TEST){
		printf("\n\n");for(j=0;j<vy;j++)printf("%d ",IPL[j]);printf("\n\n");
		printf("\n\n");for(j=0;j<vy;j++)printf("%d ",IP(Y->x[j],X->x[CX->x[i]],Y->d));
		printf("\n\n");fflush(0);
	}
	if(!checkIP) return 0;
	else{
		for(j=0;j<vy;j++) IPL[j]+=IP(Y->x[j],X->x[CX->x[i]],Y->d);
		if (TEST){ printf("\n\n");for(j=0;j<vy;j++)printf("%d ",IPL[j]);printf("\n\n");}
		SP->x[SP->n++]=i;
	}
	return 1;
}

int DUAL_CHECK(PointList *SPX, Matrix *X, PointList *CX, Long *y, int n){
	int dual_basis,j;/*check if y is dual to SPX (y e_x = d_yx) */
	Long k;
	dual_basis=1;j=0;
	while((j<SPX->n) && dual_basis){
		k=IP(X->x[CX->x[SPX->x[j]]],y,X->d);
		if(((k!=1) && (n==j)) || ((k!=0)&&(n!=j)))
			dual_basis=0;
		j++;
	}
	return dual_basis;
}

void FIND_SPY(Matrix *X, Matrix *Y, int *vx, int *vy, PointList *SPX,
						 PointList *SPY, PointList *CX, PointList *CY, int *c, SplitInfo *SI)
{
	
	if(SPY->n == SPX->n){
		int i,e[POLY_Dmax],f[POLY_Dmax];
		for(i=0;i<SPY->n;i++){e[i]=CX->x[SPX->x[i]]; f[i]=CY->x[SPY->x[i]];}
		Transform_XY(X,Y,e,f,*c,SI);
	}
	else{
		int i;
		for(i=0;i<CY->n;i++){
			if(DUAL_CHECK(SPX,X,CX,Y->x[CY->x[i]],SPY->n)){
				SPY->x[SPY->n++]=i;
				FIND_SPY(X, Y, vx, vy, SPX, SPY, CX, CY, c, SI);
				SPY->n--;
			}
		}
	}
}

void FIND_SPX(Matrix *X, Matrix *Y, int *vx, int *vy, PointList *SPX,
						 int IPL[], PointList *CX, PointList *CY, int *c, SplitInfo *SI){

	if(SPX->n == (*c-1)){/*SPX found*/
		PointList SPY;
		SPY.n=0;
		FIND_SPY(X, Y, vx, vy, SPX, &SPY, CX, CY,c,SI);
	}
	else{
		int i;
		for(i=(SPX->x[SPX->n-1]+1);i<CX->n;i++){
			SPX->x[SPX->n]=i;
			if(add_to_SP(SPX,i,IPL,*vy,CX,X,Y)){
				FIND_SPX(X, Y, vx, vy, SPX, IPL, CX, CY, c,SI);
				remove_from_SP(SPX,i,IPL,*vy,CX,X,Y);
			}
		}
	}
}

void Check_Split(PolyPointList *PN, EqList *EN, VertexNumList *VN,
								int c, SplitInfo *SI)
{
	PointList SPX,CX,CY; 
	int i, j, IPL[EQUA_Nmax],TEST=0,index=SI->index;
	int vx=VN->nv,vy=EN->ne,dim=(PN->n+1);
	Matrix X,Y;
	
	for(i=0;i<vx;i++){assert(VN->v[i] < vx);}

	SI->vx=vx; SI->vy=vy; 
	Init_Matrix(&X, POINT_Nmax, dim);
	Init_Matrix(&Y, POINT_Nmax, dim);
  /*PN,EN -> ,X,Y*/
	X.v=PN->np; Y.v=EN->ne; X.d=Y.d=dim;
	for(i=0;i<X.v;i++){X.x[i][0]=1;for(j=0;j<(dim-1);j++) X.x[i][j+1]=PN->x[i][j];}
	for(i=0;i<Y.v;i++){
		Y.x[i][0]=EN->e[i].c;
	  for(j=0;j<(dim-1);j++)Y.x[i][j+1]=EN->e[i].a[j];
	}
	X.x[X.v][0]=index; for(j=0;j<(dim-1);j++) X.x[X.v][j+1]=PN->x[PN->np][j];
	if(Find_Candidates(&X, &Y, vy, &CX)){
		if(TEST)Print_CMatrix(Y,"Y:");fflush(0);
		Complete_Y(&X,&Y,vx);
		if(TEST) Print_CMatrix(Y,"Y:");fflush(0);
		if(TEST) printf("#candidates in Nlattice:  %d  \n",CX.n);
		if(Find_Candidates(&Y, &X, vx, &CY)){
			if(TEST) printf("#candidates in Mlattice:  %d  \n",CY.n);
			for (i=0; i<(CX.n-c+2); i++){
				for(j=0;j<vy;j++)
					IPL[j]=IP(X.x[CX.x[i]],Y.x[j],Y.d);
				SPX.x[0]=i; SPX.n=1;
				if(c>1) FIND_SPX(&X, &Y, &vx, &vy,  &SPX, IPL, &CX, &CY, &c, SI);
			}		
		}
	}
	Free_Matrix(&X);Free_Matrix(&Y);
}
/*	##################			END   SPLIT:		##################	*/
void Print_Bigpoly(PolyPointList * P, Long *x, int index){
	int i,j;
	VertexNumList BV; EqList BE;
	PolyPointList *BP = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (BP == NULL) Die("Unable to allocate space for BP");
	for(i=0;i<P->np;i++)for(j=0;j<P->n;j++)BP->x[i][j]=index*P->x[i][j]-x[j];
	for(j=0;j<P->n;j++)BP->x[P->np][j]=0;
	BP->np=P->np+1; BP->n=P->n;
	Find_Equations(BP, &BV, &BE); assert(Ref_Check(BP, &BV, &BE));
	for(i=0;i<BV.nv;i++) assert(BV.v[i]<BV.nv);
	Print_VL(BP,&BV,"Vertices of index * input poly(IP=(0,...,0)):");
	/*Make_VEPM(BP,&V,&E,VPM);
	Complete_Poly(PM,E,V->nv,P);
	Print_PPL(BP,"Points of index * input poly(IP=(0,...,0)):");*/
	free(BP);
}
void dimcheck(int narg, char *fn[]){
	PolyPointList *_P = NULL;
  VertexNumList *_V = NULL;
  EqList *_E = NULL;
	Weight W;
	int FilterFlag=0,n=0,k=0;	char c;
	while(narg > ++n) {
	  if(fn[n][0]!='-') break;
	  k=0;
	  while ((c=fn[n][++k])!='\0'){
			if(c=='f') {FilterFlag=1;}
	  }
  }
  n--;
	if(FilterFlag) {inFILE=NULL; outFILE=stdout;}
  else {
    if (narg > ++n)  inFILE=fopen(fn[n],"r");
    else inFILE=stdin;
    if (inFILE==NULL){printf("Input file %s not found!\n",fn[n]);exit(0);}
    if (narg > ++n) outFILE=fopen(fn[n],"w");
    else outFILE=stdout;
	}


	
	_P = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (_P == NULL) Die("Unable to allocate space for _P");
	_V = (VertexNumList *) malloc(sizeof(VertexNumList));
	if (_V == NULL) Die("Unable to alloc space for VertexNumList _V");
	_E = (EqList *) malloc(sizeof(EqList));
	if (_E == NULL) Die("Unable to alloc space for EqList _E");

	while(Read_W_PP(&W,_P)){
		Find_Equations(_P, _V, _E);
		if(_E->ne > _P->n) {Print_Weight(&W);fprintf(outFILE,"\n");fflush(0);}
	}
	free(_P); free(_V); free(_E);
}

void Print_PW(PolyPointList *P, Weight *W, int index){
	Matrix X;
	int i,j,dim=P->n, S[VERT_Nmax];

	Init_Matrix(&X, POINT_Nmax, (dim+1));
	X.v=P->np; X.d=dim+1;assert(X.v<VERT_Nmax);
	for(i=0;i<X.v;i++){X.x[i][0]=1;for(j=0;j<(dim);j++) X.x[i][j+1]=P->x[i][j];}
	/*Print_LMatrix(X, "Print_PW");*/
	WeightToDualPoints(W, &X, S, index);
  fprintf(outFILE,"%d %d Points of Poly in N-lattice:\n",dim,P->np); 
	for(i=0;i<dim;i++){
		for(j=0;j<P->np;j++)
			fprintf(outFILE,"%2d%s",(int) P->x[j][i],(j+1==P->np) ? "\n" : " ");}
	for(j=0;j<P->np;j++)fprintf(outFILE,"--%s", (j+1==P->np) ? "\n" : "-");
	for(j=0;j<P->np;j++)fprintf(outFILE,"%2d%s", S[j],(j+1==P->np) ? "\n" : " ");	
	Free_Matrix(&X);
}

void gen(int narg, char *fn[]){
	/*	##################			BEGIN FLAGS:		##################	*/
	int FilterFlag=0, CHECK_SERRE=0, SINFO=0, TEST=0, H=0, P=0, V=0, S=1, L=0, D=0;
	int TRANSFORMATION=0, BIGPOLY=0, HODGE=1, CODIM=0, SPOLY=0, SLPOLY=0; 
  /*	##################			END   FLAGS:		##################	*/
	
	int n=0,k=0,codim=1,Dim,h[POLY_Dmax][POLY_Dmax] = {{0}, {0}};
	char c;
	Weight W;
	PolyPointList *_P = NULL, *_P_D, *_P_N;
  VertexNumList *_V = NULL, *_V_D, *_V_N;
  EqList *_E = NULL, *_E_D, *_E_N;
  FaceInfo *_I_D;
  Cone *_C_D, *_C_N;
  Poset_Element_List PEL_D, PEL_N;
  Interval_List IL;
  SPoly *_S_D = NULL, *_S_N = NULL;
  BPoly *_BL = NULL;
  EPoly EP;
	
  while(narg > ++n) {
	  if(fn[n][0]!='-') break;
	  k=0;
	  while ((c=fn[n][++k])!='\0'){
			if(c=='H') { H=1;}/*full hodge info*/
			if(c=='p') { P=1;}/*print points of small poly (N lattice)*/
			if(c=='d') { D=1;}/*print points of small poly (Mlattice)*/
			if(c=='l') { L=1;}/*print points of small poly + Weights*/
			if(c=='v') { V=1;}/*print vertices of small poly*/
			if(c=='S') { S=1;}/*check split*/
			if(c=='s') { HODGE=0;}/*no hodge calculation*/
			if(c=='P') { SPOLY=1;}/*print vertices of split poly*/
			if(c=='L') { SLPOLY=1;}/*print vertices of split poly*/
			if(c=='t') { TRANSFORMATION=1;}/*show transformations*/
			if(c=='r') { BIGPOLY=1;}/*show r x small poly*/
			if(c=='f') {FilterFlag=1;}
	  }
  }
  n--;
	_P = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (_P == NULL) Die("Unable to allocate space for _P");
	_V = (VertexNumList *) malloc(sizeof(VertexNumList));
	if (_V == NULL) Die("Unable to alloc space for VertexNumList _V");
	_E = (EqList *) malloc(sizeof(EqList));
	if (_E == NULL) Die("Unable to alloc space for EqList _E");
	_P_N = (PolyPointList *) malloc(sizeof(PolyPointList));
  if (_P_N == NULL) Die("Unable to alloc space for PolyPointLis _P_N");
	_V_N = (VertexNumList *) malloc(sizeof(VertexNumList));
  if (_V_N == NULL) Die("Unable to alloc space for VertexNumList _V_N");
	_E_N = (EqList *) malloc(sizeof(EqList));
  if (_E_N == NULL) Die("Unable to alloc space for EqList _E_N");
	 _I_D = (FaceInfo *) malloc(sizeof(FaceInfo));
  if (_I_D == NULL) Die("Unable to alloc space for FaceInfo _I_D");
  _C_D = (Cone *) malloc(sizeof(Cone));
  if (_C_D == NULL) Die("Unable to alloc space for Cone _C_D");
  _C_N = (Cone *) malloc(sizeof(Cone));
  if (_C_N == NULL) Die("Unable to alloc space for Cone _C_N");
	
	if(FilterFlag) {inFILE=NULL; outFILE=stdout;}
  else {
    if (narg > ++n)  inFILE=fopen(fn[n],"r");
    else inFILE=stdin;
    if (inFILE==NULL){printf("Input file %s not found!\n",fn[n]);exit(0);}
    if (narg > ++n) outFILE=fopen(fn[n],"w");
    else outFILE=stdout;
	}FilterFlag=1;
	while(Read_W_PP(&W,_P)){
		int index=W.r, cd=index, split=0, fib=0, nl=1;
		if(W.R){
			assert((_P->np< (POINT_Nmax-1)));
			{for(k=0;k<_P->n;k++)_P->x[_P->np][k]=W.rI[k];} /*dirty fix*/
			if (CODIM) cd=CODIM;
			if(TEST){
				fprintf(outFILE, "\n GENERIC \n");fflush(0);
				fprintf(outFILE, "index:	 %d \n", index);fflush(0);
			}
			Find_Equations(_P, _V, _E);
			if(_E->ne > _P->n){
				_P_D=_P; _V_D=_V; _E_D=_E;
				Make_PEV_N(_P_N, _P_D, _E_N, _E_D, _V_N, _V_D, index);
				if(TEST){
					Print_VL(_P_D, _V_D, "Vertices of P");
					Print_EL(_E_D,&_P_D->n,0,"Equations of P");
				}
				/*Print_PPL(_P_D,"");Print_PPL(_P_N,"");*/
				if(TEST){
					Make_PEV_N(_P_D, _P_N, _E_D, _E_N, _V_D, _V_N, index);
					Make_PEV_N(_P_N, _P_D, _E_N, _E_D, _V_N, _V_D, index);
				}
				if (BIGPOLY) Print_Bigpoly(_P_N,_P_N->x[_P_N->np],index);
				if(S&&(cd>1)){
					SplitInfo SI; if(SPOLY) SI.p=1; if(SLPOLY) SI.l=1; SI.t=0; SI.nl=1;
					if(TRANSFORMATION) SI.t=1;
					SI.n=0; SI.d=W.d; SI.f=0; SI.W=&W; SI.index=index;SI.fib=1;
					Check_Split(_P_N,_E_N,_V_N,cd,&SI);
					if(SI.n) split=1; if(SI.f) fib=1; SI.a=0;
					if(SI.n>1) fprintf(outFILE,"found different split!");
					nl=SI.nl;
				}
				if(V) Print_VL(_P_N, _V_N, "Vertices of Poly in N lattice:");
				if(P) Print_PPL(_P_N,"Points of Poly in N lattice");
				if(L) {Print_PW(_P_N,&W,index);}
				if(D) Print_PPL(_P_D,"Points of Poly in M lattice");
				OUT(&W, index, split, fib, _P_N->np, _V_N->nv, _P_D->np, _V_D->nv,nl);
				if(HODGE){
					int chi=0,diff=(index-codim),dim;
					Make_Incidence(_P_D, _V_D, _E_D, _I_D);
					Make_Cone(_C_D, _C_N, _I_D, _P_D);
					PEL_D.n = Num_Pos(_C_D); PEL_N.n = Num_Pos(_C_N);
					
					PEL_D.L = (Poset_Element *) calloc(PEL_D.n, sizeof(Poset_Element));
					if (PEL_D.L == NULL) Die("Unable to alloc space for PEL_D.L");
					PEL_N.L = (Poset_Element *) calloc(PEL_D.n, sizeof(Poset_Element));
					if (PEL_N.L == NULL) Die("Unable to alloc space for PEL_N.L");
					
					Make_PosetList(_C_D, &PEL_D); Make_PosetList(_C_N, &PEL_N);
				
					_S_D = (SPoly *) calloc(PEL_D.n, sizeof(SPoly ));
					if (_S_D == NULL) Die("Unable to alloc space for SPoly _S_D");
					_S_N = (SPoly *) calloc(PEL_D.n, sizeof(SPoly ));
					if (_S_N == NULL) Die("Unable to alloc space for SPoly _S_N");
			
					Make_S_Poly(_C_N, _V_D, _E_D, _P_D, &PEL_D, _S_D, SINFO, CHECK_SERRE);
					if(TEST){
						int k;
						for(k=0; k < _P_D->n; k++)
							fprintf(outFILE,"  %d  ", (int) _S_D[PEL_D.n - 1].S[k]);
						printf("\n");fflush(0);
					}
					Make_S_Poly(_C_D, _V_N, _E_N, _P_N, &PEL_N, _S_N, SINFO, CHECK_SERRE);
					if(TEST){
						int k;
						for(k=0; k < _P_N->n; k++)
							fprintf(outFILE,"  %d  ", (int) _S_N[PEL_D.n - 1].S[k]);
						printf("\n");fflush(0);
					}

					Make_PosetList(_C_D, &PEL_D); Make_PosetList(_C_N, &PEL_N);
					IL.L = (Interval *) calloc(((1 + PEL_D.n)/2 + 1)*PEL_D.n, 
																	 sizeof(Interval));
					if (IL.L == NULL) Die("Unable to alloc space for IL.L");
					
					Make_Intervallist(&IL, &PEL_D, _C_D);
					
					_BL = (BPoly *) calloc(IL.n, sizeof(BPoly));
					if (_BL == NULL) Die("Unable to alloc space for _BL");
				
					Make_B_Poly(_C_D, &PEL_D, &IL, _BL);

					SB_To_E(&EP, _C_D, &PEL_D, _BL, &IL, _S_D, _S_N, &codim);
					dim=(_P->n - codim); Dim=(_P_D->n + 1);
			
					chi=MAKE_h(&EP, h, Dim, dim);
					assert(CHECK_HODGE(h,&W));
					OUT_HODGE(h, dim, H,chi,diff);
					free(PEL_D.L); free(PEL_N.L); free(_S_D); free(_S_N); free(IL.L); 
					free(_BL);
				}
				fprintf(outFILE, "\n");
			}
		}
	}
	free(_P); free(_V); free(_E);
	free(_P_N); free(_V_N);  free(_E_N);
	free(_I_D); free(_C_D); free(_C_N);
}

void FindSplit(int narg, char *fn[]){
/*	##################			BEGIN FLAGS:		##################	*/
	int FilterFlag=0, TRANSFORMATION=0, MULTISPLIT=0, SPLIT=0, ALLSPLIT=0;
/*	##################			END   FLAGS:		##################	*/
	char c; int n=0,k=0; int index=2,p;
	CWS *CW=(CWS *) malloc(sizeof(CWS));
	VertexNumList *V=NULL,*V_N=NULL;
	EqList *E=NULL,*E_N=NULL;
	PolyPointList *P=NULL,*P_D=NULL,*P_N=NULL,*DP=NULL;
	PartList *PTL=NULL;
	Long PM[EQUA_Nmax][VERT_Nmax];
	NEF_Flags NF;
	SplitInfo SI;

	
	P = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (P == NULL) Die("Unable to alloc space for  PolyPointLis P");
	E = (EqList *) malloc(sizeof(EqList));
  if (E == NULL) Die("Unable to alloc space for EqList E");
	V = (VertexNumList *) malloc(sizeof(VertexNumList));
  if (V == NULL) Die("Unable to alloc space for VertexNumList V");
	PTL = (PartList *) malloc(sizeof(PartList));
  if (PTL == NULL) Die("Unable to alloc space for PartList PTL");
  P_D = (PolyPointList *) malloc(sizeof(PolyPointList));
  if (P_D == NULL) Die("Unable to alloc space for PolyPointLis P_D");
  P_N = (PolyPointList *) malloc(sizeof(PolyPointList));
  if (P_N == NULL) Die("Unable to alloc space for PolyPointLis P_N");
  V_N = (VertexNumList *) malloc(sizeof(VertexNumList));
  if (V_N == NULL) Die("Unable to alloc space for VertexNumList V_N");
  E_N = (EqList *) malloc(sizeof(EqList));
  if (E_N == NULL) Die("Unable to alloc space for EqList E_N");
  DP = (PolyPointList *) malloc(sizeof(PolyPointList));
  if (DP == NULL) Die("Unable to alloc space for PolyPointLis DP");
	
	while(narg > ++n) {
	  if(fn[n][0]!='-') break;
	  k=0;
	  while ((c=fn[n][++k])!='\0'){
			if(c=='c'){
				if(fn[n][k+1]!=0){
					if(!IsDigit(fn[n][k+1])) Die("after -c only digits or nothing!");
					index=atoi(&fn[n][k+1]);
				}
			}
			if(c=='f') {FilterFlag=1;}
			if(c=='m') {MULTISPLIT=1;}/*print poly if multiple splits*/
			if(c=='s') {SPLIT=1;}/*print poly if it splits*/
			if(c=='a') {ALLSPLIT=1;}/*print all different splits*/
	  }
  }
  n--;
	if(FilterFlag) {inFILE=NULL; outFILE=stdout;}
  else {
    if (narg > ++n)  inFILE=fopen(fn[n],"r");
    else inFILE=stdin;
    if (inFILE==NULL){printf("Input file %s not found!\n",fn[n]);exit(0);}
    if (narg > ++n) outFILE=fopen(fn[n],"w");
    else outFILE=stdout;
	}
	while(Read_CWS_PP(CW,P)) {
		int split=0,multisplit=0;
		Find_Equations(P,V,E);
		Make_VEPM(P,V,E,PM);
		Complete_Poly(PM,E,V->nv,P);
		Sort_VL(V); Sort_PPL(P, V);
		Make_Dual_Poly(P, V, E, DP);
		NF.Sym=1; NF.noconvex=0; NF.Test=0; NF.Sort=1;
		
		part_nef(P, V, E, PTL, &index, &NF);
		
		for (p=0;p<PTL->n;p++){
			int fib=0,i;
			if(ALLSPLIT) fprintf(outFILE,"\n  Partition #%d:  \n",p);
			Make_Gore_Poly(P, DP, P_N, P_D, V, PTL, &index, &p);
			/*Print_PPL(P_D,"Points of P_D");
			Print_PPL(P_N,"Points of P_N");*/
			Find_Equations(P_N, V_N, E_N); Sort_PPL(P_N, V_N);
			SI.t=0; if(TRANSFORMATION) SI.t=1;SI.p=0; SI.a=0; if(ALLSPLIT) SI.a=1;
			SI.n=0; SI.d=0; SI.f=0; SI.l=0; SI.W=NULL; SI.index=index;SI.fib=0;
			assert(P_N->np<POINT_Nmax-1);
			for(i=0;i<index-1;i++) P_N->x[P_N->np][i]=1;
			for(i=index-1;i<P_N->n;i++) P_N->x[P_N->np][i]=0;
			Check_Split(P_N,E_N,V_N,index,&SI);
			if(SI.n) split=1; if(SI.f) fib=1;SI.p=1;
			if(SI.n>1) multisplit=1;
		}
		if(!ALLSPLIT){
			if(MULTISPLIT && multisplit) Print_PPL(P,"Points of P:");
			else
				if(split && SPLIT) Print_PPL(P,"Points of P:");
		}
	}
  free(P);free(V);free(E);free(CW);free(P_D);
	free(P_N);free(V_N);free(E_N);free(PTL);free(DP);
}

int main(int narg, char *fn[]){
	char c; int n=0,k=0;
	
	
	while(narg > ++n) {
	  if(fn[n][0]!='-') break;
	  k=0;
	  while ((c=fn[n][++k])!='\0'){
			if(c=='c'){ FindSplit(narg, fn); exit(0);}
			if(c=='W'){ dimcheck(narg, fn); exit(0);}
			if(c=='h'){ PrintUsage(fn[0]); exit(0);}
			if(c=='x'){ PrintXUsage(fn[0]); exit(0);}
	  }
  }
  n--;
	gen(narg, fn);
	return(1);
}

/* ####################				OLD STUFF 			############################*/

void PNtoL(Matrix *X, int e[POLY_Dmax], int cd, SplitInfo *SI){

	PolyPointList *AP = NULL;
	int i,j,k=0,index=0;
	
  AP = (PolyPointList *) malloc(sizeof(PolyPointList));
	if (AP == NULL) Die("Unable to alloca	te space for AP");
  index=X->x[X->v][0]; assert(index==cd); assert(X->v+1<FIB_POINT_Nmax);
  for(i=0;i<X->v;i++){
		assert(X->x[i][0]==1);
		if(e[k]!=i){
			for(j=1;j<X->d;j++) AP->x[i-k][j-1]=index*X->x[i][j]-X->x[X->v][j];
		}
		else{
			for(j=1;j<X->d;j++) AP->x[k+X->v-cd][j-1]=index*X->x[i][j]-X->x[X->v][j];
			k++;
		}
	}
	assert(k==cd);
	for(j=1;j<X->d;j++)AP->x[X->v][j-1]=0;
	AP->n=X->d-1; AP->np=X->v+1;
	{	int w_OK=0;
		int N=0,p=1,v=0;
		EqList AE;
		VertexNumList AV;
		LInfo L;
		
		/*fprintf(outFILE,"\n\n index x small poly:\n\n");*/
		/*Print_PPL(AP,"Points of P");fflush(0);*/
		Find_Equations(AP,&AV,&AE);
		assert(Ref_Check(AP,&AV,&AE));
		if(v) N=AV.nv; if(p) N=AP->np;
		Make_L(AP, &AV, &L ,p,v);/*PrintL(&L,p,v);*/
		k=0;w_OK=0;
		while((!w_OK) && (k<L.nw)){
			i=0; for(j=0;j<L.nv;j++){i+=L.W[k][j];}
			if(i==SI->d*index){
				w_OK=1;
				for(j=0;j<L.nv;j++){if(SI->S[j]!=L.W[k][j]) w_OK=0;}
			}
			k++;
		}
		assert(w_OK);
	}
	free(AP);
}
