#include "Global.h"

FILE *inFILE, *outFILE;

#define GL_Long		Long

int  PM_to_GLZ_for_UTriang(Long M[][VERT_Nmax],int *d,int *v,/* return rank */
                       GL_Long G[POLY_Dmax][POLY_Dmax]);  /* allows rank<*d */

void PrintUsage(char *c)
{    puts("Input \"#pts dim\" and then #pts lines vectors");
     exit(0);
}

void FE(){puts("Input format error");exit(0);}
int  IsDigit(char c) { return (('0'<=c) && (c<='9'));}
int  ReadInt()
{    int n; char c=fgetc(inFILE); if(!IsDigit(c)&&(c!='-')) FE();
     ungetc(c,inFILE); fscanf(inFILE,"%d",&n); 
     while(' '==(c=fgetc(inFILE))); ungetc(c,inFILE); return n;
}

int  ReadPoints(PolyPointList *_P)
{    int d,n,i,j; char c=fgetc(inFILE); if(!IsDigit(c)) return 0;
     ungetc(c,inFILE); fscanf(inFILE,"%d",&d); _P->np=d;
     while(' '==(c=fgetc(inFILE))); if(!IsDigit(c)) FE();
     ungetc(c,inFILE); fscanf(inFILE,"%d",&n); _P->n=n;
     assert(n<=POLY_Dmax); /* need  dim <= POLY_Dmax */
     assert(d<=VERT_Nmax); /* need #pts <= VERT_Nmax */
     while(' '==(c=fgetc(inFILE ))); if(IsDigit(c)) FE(); ungetc(c,inFILE);
     while('\n'!=(c=fgetc(inFILE ))) if(feof(inFILE)) FE();
     for(i=0;i<d;i++)
     {  for(j=0;j<n;j++) _P->x[i][j]=ReadInt(); 
	while('\n'!=(c=fgetc(inFILE ))) if(feof(inFILE)) FE();
     }	return 1;
}
int  main (int narg, char* fn[])
{    int k, n=1, r; VertexNumList V; CWS *CW=(CWS *) malloc(sizeof(CWS));
     EqList *E = (EqList *) malloc(sizeof(EqList));
     PolyPointList *_P = (PolyPointList *) malloc(sizeof(PolyPointList));
     if((CW==NULL)||(E==NULL)||(_P==NULL)) {
    	puts("Allocation failure: Reduce dimensions!"); exit(0);} CW->nw=0;
     {	if (narg > 1) if (fn[n][0]=='-') PrintUsage(fn[0]);
     	if (narg > 1) inFILE=fopen(fn[1],"r"); else inFILE=stdin;
    	if (narg > 2) outFILE=fopen(fn[2],"w"); else outFILE=stdout;     
        if(inFILE==NULL) {puts("Cannot open input file"); exit(0);}
        if(outFILE==NULL) {puts("Cannot open output file"); exit(0);}
     }
     while(ReadPoints(_P))
     {	Long M[POLY_Dmax][VERT_Nmax]; GL_Long G[POLY_Dmax][POLY_Dmax];
	for(n=0;n<_P->np;n++) for(k=0;k<_P->n;k++) M[k][n]=_P->x[n][k];
	r=PM_to_GLZ_for_UTriang(M,&_P->n,&_P->np,G);
	for(n=0;n<_P->np;n++) for(k=0;k<_P->n;k++)
        {   int j; _P->x[n][k]=0;
	    for(j=0;j<_P->n;j++) _P->x[n][k]+=G[k][j]*M[j][n];
	}   n=_P->n; _P->n=r; Find_Equations(_P,&V,E); Sort_VL(&V);
	for(k=0;k<V.nv;k++)fprintf(outFILE,"%d ",V.v[k]+1);
	fprintf(outFILE," #vert=%d rank=%d  (1<=v<=#vert)\n",V.nv,r);
     }	return 0;
}
